#ifndef BZP_BEZIER_H
#define BZP_BEZIER_H

#include "site.h"

#ifdef __cplusplus
#include <memory>
#endif

/*************************************************

	xWGȐ𕪊NX

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FPoint;
class FRect;
class Knot;
class BezierMember;

class Bezier
{
public:
	Bezier(const FPoint & anchorA,const FPoint & forwardA,const FPoint & backB,const FPoint & anchorB);
	Bezier(const Knot *curKnot,const Knot *nextKnot);
	~Bezier() throw();
	bool IsPointInArea(const FPoint & point,const FPoint & area) const;	/*_xWGȐ͈͓̔ɂ\*/
	bool IsOutRect(const FRect &rect) const;
	bool IsInRect(const FRect &rect) const;
	void Divide(double t=0.5);	/*xWGȐ̕*/
	bool IsNarrow(const FPoint & maxSize) const;	/*xWGȐ̍ł傫ꍇ̑傫[ɏ*/
	bool IsNarrowWidthByDot(double resolution) const;
	bool IsNarrowHeightByDot(double resolution) const;
	double MaxWidth() const;
	double MaxHeight() const;
	bool DoesPassLine(double y) const;
	bool IsNotCurve() const; /*ɂȂĂ邩*/
	double Distance(const FPoint & point,const FPoint & base) const;	/*̒ʉߓ_Ɠ_Ƃ̋*/
	bool Next();	/*X^bNɎcĂ邽߂ɏ*/
	double GetCenter_t() const	/*̒ԓ_̃xWGȐ̒`ŌƂ̔}ϐt̒l*/
	{
		return m_b_t;
	}

	/*̍W𓾂*/
	FPoint GetAnchorA() const;
	FPoint GetForwardA() const;
	FPoint GetBackB() const;
	FPoint GetAnchorB() const;
protected:
	void SetMaxRect(FRect *rect) const;

	double MaxX() const;
	double MinX() const;
	double MaxY() const;
	double MinY() const;
private:
	Bezier();	/*`ĂȂ*/
	Bezier(const Bezier &source);

	const std::auto_ptr<BezierMember> m_m;

	double m_a_t;	/*O̒ʉߓ_̃xWGȐ̒`ŌƂ̔}ϐ̒l*/
	double m_b_t;	/*̒ʉߓ_̔}ϐ̒l*/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif