#include "prefix.h"

#include "cdiff.h"
#include "cerror.h"
#include "diff.h"

/*************************************************

	DiffCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZDifferenceSize(const BZPath previousPath,const BZPath currentPath,int *size)
{
	NullCheck(size);

	TRY {
		*size=DifferenceSize(previousPath,currentPath);
	} CATCH;
}

BZPERROR BZP_API BZCreateDifference(const BZPath previousPath,const BZPath currentPath,char *buffer,int maxSize,int *size)
{
	NullCheck(size);

	TRY {
		*size=CreateDifference(previousPath,currentPath,buffer,maxSize);
	} CATCH;
}

BZPERROR BZP_API BZUndoRedoPath(bool undo,BZPath destPath,const BZPath currentPath,const char *diff,int size)
{
	TRY {
		UndoRedoPath(undo,destPath,currentPath,diff,size);
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END

