#include "prefix.h"

#include "cgraph.h"
#include "cerror.h"
#include "graph.h"

/*************************************************

	GraphCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZGraph_Create(BZGraph *graph)
{
	NullCheck(graph);

	TRY {
		*graph=NULL;
		*graph=new Graph;
	} CATCH;
}

void BZP_API BZGraph_Destroy(BZGraph graph)
{
	delete graph;
}

BZPERROR BZP_API BZGraph_SetViewRect(BZGraph graph,const RECT *rect)
{
	NullCheck(graph);
	NullCheck(rect);
	TRY {
		graph->SetViewRect(*rect);
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetBoundRect(BZGraph graph,const RECT *rect)
{
	NullCheck(graph);
	TRY {
		graph->SetBoundRect(*rect);
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetDrawMode(BZGraph graph,int drawMode)
{
	NullCheck(graph);
	TRY {
		graph->SetDrawMode(drawMode);
	} CATCH;
}

BZPERROR BZP_API BZGraph_GetDrawMode(BZGraph graph,int *mode)
{
	NullCheck(graph);
	NullCheck(mode);
	TRY {
		*mode=graph->GetDrawMode();
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetViewDC(BZGraph graph,HDC hDC)
{
	NullCheck(graph);
	NullCheck(hDC);
	TRY {
		graph->SetViewDC(hDC);
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetColor(BZGraph graph,COLORREF color)
{
	NullCheck(graph);
	TRY {
		graph->SetColor(color);
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetInvertColor(BZGraph graph,COLORREF color)
{
	NullCheck(graph);
	TRY {
		graph->SetInvertColor(color);
	} CATCH;
}

BZPERROR BZP_API BZGraph_SetPartsSize(BZGraph graph,PARTSSIZE parts,int size)
{
	NullCheck(graph);
	TRY {
		graph->SetPartsSize(parts,size);
	} CATCH;
}

BZPERROR BZP_API BZGraph_GetPartsSize(BZGraph graph,PARTSSIZE parts,int *size)
{
	NullCheck(graph);
	NullCheck(size);
	TRY {
		*size=graph->GetPartsSize(parts);
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END
