#ifndef BZP_CONVERTER_BASE_H
#define BZP_CONVERTER_BASE_H

#include "site.h"

#ifdef __cplusplus
#include <memory>
#endif

/*************************************************

	pXƉ炩̌`ɕϊ{NX

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FPoint;
class Rect;

/*pX牽炩̌`ɕϊ*/
class PathTo
{
public:
	PathTo();
	virtual ~PathTo() throw();

	virtual void WriteStartPath(const Rect &boundRect) {};
	virtual void WriteEndPath() {}
	virtual void WriteStartCurve(bool isSelected,bool isClosed) {}
	virtual void WriteEndCurve() {}
	virtual void WriteStartSubGroup(bool isSelected) {}
	virtual void WriteEndSubGroup() {}
	virtual void WriteKnot(const FPoint & back,const FPoint & anchor,const FPoint & forward,int mode) {}

protected:
	void SetBoundRect(const Rect &rect);
	const std::auto_ptr<Rect> m_boundRect;	/*pX̎W̋`*/

private:
};

/*炩̌`pXɕϊ*/
class ToPath
{
public:
	ToPath();
	virtual ~ToPath() throw();

	virtual void ReadStartPath(Rect *boundRect) {}
	virtual void ReadEndPath() {}
	virtual void ReadStartSubGroup() {}
	virtual void ReadEndSubGroup(bool *isSelected) {}
	virtual void ReadStartCurve() {}
	virtual void ReadEndCurve(bool *isSelected,bool *isClosed,bool *isOverlappedCloser) {}
	virtual void ReadKnot(FPoint *back,FPoint *anchor,FPoint *forward,int *mode) {}
	virtual bool IsSubGroupOpened() { return false;}
	virtual bool IsCurve() { return false; }
	virtual bool IsKnot() { return false; }

//	void GetBoundRect(Rect *rect) const;

protected:
	void SetBoundRect(const Rect &rect);
	const std::auto_ptr<Rect> m_boundRect;	/*pX̎W̋`*/

private:
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif



