#ifndef BZP_CONVERTER_BUFFER_H
#define BZP_CONVERTER_BUFFER_H

#include "site.h"

#ifdef __cplusplus
#include <memory>

#include "converterbase.h"
#endif

/*************************************************

	pXƉ炩̌`ɕϊăobt@[ɓ

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FPoint;
class Rect;
class Path;

/*pXobt@[*/
class PathToBuffer : public PathTo
{
public:
	PathToBuffer();
	virtual ~PathToBuffer() throw();

	int Size() const;	/*obt@̕KvȃoCg܂͏񂾃oCg*/
	void SetBuffer(char *buffer,int size);	/*obt@ݒ肷*/
protected:
	LONG GetPointer() const;
	bool CountOnly() const;

	void WriteData(const char *data,int size,LONG offset=-1);
	void WriteLong(LONG value,LONG offset=-1);
	void WriteShort(SHORT value);
	void WriteChar(char value);
	void WriteBool(bool flag);
	void SubWriteInt(LONG value,int intSize,LONG offset=-1);
	void WriteFixedPointPoint(const FPoint & point);
	void WriteFixedPoint(double value);
	void WriteRect(const Rect &rect);
	void IncrementPointer(int size);

private:
	char *m_buffer;	/*obt@̃AhXL͂ȂAvP[VmۂĐݒ肷*/
	int m_bufferSize;	/*obt@̑傫*/
	LONG m_pointer;	/*obt@̈ʒu*/
};

/*obt@[pX*/
class BufferToPath : public ToPath
{
public:
	BufferToPath();
	virtual ~BufferToPath() throw();

	void SetBuffer(const char *buffer,int size);	/*obt@ݒ肷*/
protected:
	LONG GetPointer() const;
	const char *GetBuffer() const;
	const char *GetCurrent() const;
	int Size() const;

	void ReadData(char *data,int size);
	LONG ReadLong();
	SHORT ReadShort();
	char ReadChar();
	bool ReadBool();
	ULONG SubReadUInt(int intSize);
	LONG SubReadInt(int intSize);
	FPoint ReadFixedPointPoint();
	double ReadFixedPoint();
	void ReadRect(Rect *rect);
	SHORT CheckShort() const;
	LONG CheckLong() const;
	LONG SubCheckInt(int intSize) const;
	void CheckData(char *data,int size) const;
	void IncrementPointer(int size);

private:
	const char *m_buffer;	/*obt@̃AhXL͂ȂAvP[VmۂĐݒ肷*/
	int m_bufferSize;	/*obt@̑傫*/
	LONG m_pointer;	/*obt@̈ʒu*/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
