#ifndef BZP_CONVERTER_TABLE_H
#define BZP_CONVERTER_TABLE_H

#include "site.h"
#include "fpointbase.h"

/*************************************************

	e[u`ɕϊ

**************************************************/

BZP_NAMESPACE_START

enum PATHTABLETYPE	/*e[u̎*/
{
	PATHTABLE_HEADER,
	PATHTABLE_KNOT,
	PATHTABLE_CURVE,
	PATHTABLE_SUBGROUP_OPEN,
	PATHTABLE_SUBGROUP_CLOSE,

	PATHTABLE_END
};

#include "structpack_on.h"

struct tagPATHTABLE	/*e[u̍\*/
{
	LONG type;	/*e[u̎*/
	union
	{
		struct /*擪̃e[u*/
		{
			RECT boundRect;	/*W`*/
		} header;

		struct /*Ĩe[u*/
		{
		} end;

		struct	/*pڂ̃e[u*/
		{
			FPOINT back;	/*̕_*/
			FPOINT anchor;	/*ʉߓ_*/
			FPOINT forward;	/*O̕_*/
			LONG mode;	/*pڂ̏*/
		} knot;

		struct	/*̃e[u*/
		{
			unsigned isSelected :1;	/*IĂ邩*/
			unsigned isClosed :1;	/*Ă邩*/
		} curve;

		struct	/*TuO[ṽe[u*/
		{
			unsigned isSelected :1;	/*IĂ邩 Ƃɂ͕Kfalse*/
		} subGroup;
	};
};

#include "structpack_off.h"

typedef tagPATHTABLE PATHTABLE;

#ifdef __cplusplus

class Path;

/*ϊ̃e[ũoCgvZ*/
int PathToTableSize(const Path *path,int part);
/*ϊ̃e[u̐vZ*/
int PathToTableCount(const Path *path,int part);

/*pXe[u`ɕϊ*/
int PathToTable(const Path *path,int part,PATHTABLE *buffer,int maxSize);
/*e[u`pXɂ*/
void TableToPath(Path *path,const PATHTABLE *buffer,int size);

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif



