#include "prefix.h"

#include "cpath.h"
#include "cerror.h"
#include "path.h"
#include "clip.h"
#include "fpoint.h"

/*************************************************

	PathCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZPath_Create(BZPath *path)
{
	NullCheck(path);
	TRY {
		*path=NULL;
		*path=new Path;
	} CATCH;
}

void BZP_API BZPath_Destroy(BZPath path)
{
	delete path;
}

BZPERROR BZP_API BZPath_GetOuterRect(BZPath path,RECT *rect,int part,double precision)
{
	NullCheck(path);
	TRY {
		path->GetOuterRect(rect,part,precision);
	} CATCH;
}

BZPERROR BZP_API BZPath_IsEmpty(BZPath path,BOOL *isEmpty)
{
	NullCheck(path);
	NullCheck(isEmpty);
	TRY {
		*isEmpty=path->IsEmpty();
	} CATCH;
}

BZPERROR BZP_API BZPath_SelectAll(BZPath path,BOOL doesSelect)
{
	NullCheck(path);
	TRY {
		path->SelectAll(doesSelect!=FALSE);
	} CATCH;
}

BZPERROR BZP_API BZPath_PutInGroup(BZPath path)
{
	NullCheck(path);
	TRY {
		path->PutInGroup();
	} CATCH;
}

BZPERROR BZP_API BZPath_Ungroup(BZPath path)
{
	NullCheck(path);
	TRY {
		path->Ungroup();
	} CATCH;
}

BZPERROR BZP_API BZPath_CanGroup(BZPath path,BOOL *canGroup)
{
	NullCheck(path);
	NullCheck(canGroup);
	TRY {
		*canGroup=CanGroup(path);
	} CATCH;
}

BZPERROR BZP_API BZPath_CanUngroup(BZPath path,BOOL *canUngroup)
{
	NullCheck(path);
	NullCheck(canUngroup);
	TRY {
		*canUngroup=CanUngroup(path);
	} CATCH;
}

BZPERROR BZP_API BZPath_CanCopy(BZPath path,BOOL *canCopy)
{
	NullCheck(path);
	NullCheck(canCopy);
	TRY {
		*canCopy=CanCopy(path);
	} CATCH;
}

BZPERROR BZP_API BZPath_CopyParts(BZPath destPath,const BZPath srcPath,int part)
{
	TRY {
		CopyParts(destPath,srcPath,part);
	} CATCH;
}

BZPERROR BZP_API BZPath_CopyAll(BZPath destPath,const BZPath srcPath)
{
	TRY {
		destPath->Copy(srcPath);
	} CATCH;
}

BZPERROR BZP_API BZPath_Copy(BZPath destPath,const BZPath srcPath,BOOL cutKnot)
{
	TRY {
		Copy(destPath,srcPath,cutKnot!=FALSE);
	} CATCH;
}

BZPERROR BZP_API BZPath_Cut(BZPath destPath,const BZPath srcPath,BOOL cutKnot)
{
	TRY {
		Cut(destPath,srcPath,cutKnot!=FALSE);
	} CATCH;
}

BZPERROR BZP_API BZPath_Paste(BZPath destPath,const BZPath clipboardPath,SIZE imageSize)
{
	TRY {
		Paste(destPath,clipboardPath,imageSize);
	} CATCH;
}

BZPERROR BZP_API BZPath_Move(BZPath path,double x,double y)
{
	TRY {
		path->Move(x,y);
	} CATCH;
}

BZPERROR BZP_API BZPath_HReverse(BZPath path)
{
	TRY {
		path->HReverse();
	} CATCH;
}

BZPERROR BZP_API BZPath_VReverse(BZPath path)
{
	TRY {
		path->VReverse();
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END
