#include "prefix.h"

#include "credraw.h"
#include "cerror.h"
#include "redraw.h"

/*************************************************

	RedrawCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZRedraw_Create(BZRedraw *redraw)
{
	NullCheck(redraw);
	TRY {
		*redraw=NULL;
		*redraw=new Redraw;
	} CATCH;
}

void BZP_API BZRedraw_Destroy(BZRedraw redraw)
{
	delete redraw;
}

BZPERROR BZP_API BZRedraw_SetPath(BZRedraw redraw,BZPath path)
{
	NullCheck(redraw);
	TRY {
		redraw->SetPath(path);
	} CATCH;
}

BZPERROR BZP_API BZRedraw_SetGraph(BZRedraw redraw,BZGraph graph)
{
	NullCheck(redraw);
	TRY {
		redraw->SetGraph(graph);
	} CATCH;
}

BZPERROR BZP_API BZRedraw_SetTool(BZRedraw redraw,BZTool tool)
{
	NullCheck(redraw);
	TRY {
		redraw->SetTool(tool);
	} CATCH;
}

BZPERROR BZP_API BZRedraw_PrepareBefore(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->PrepareBefore();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_DrawBefore(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->DrawBefore();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_SkipBefore(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->SkipBefore();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_PrepareAfter(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->PrepareAfter();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_DrawAfter(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->DrawAfter();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_SkipAfter(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->SkipAfter();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_PrepareDraw(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->PrepareDraw();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_Draw(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->Draw();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_SkipDraw(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->SkipDraw();
	} CATCH;
}

BZPERROR BZP_API BZRedraw_End(BZRedraw redraw)
{
	NullCheck(redraw);
	TRY {
		redraw->End();
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END
