#include "prefix.h"

#include "csteps.h"
#include "cerror.h"
#include "steps.h"
#include "error.h"
#include "fpoint.h"

/*************************************************

	StepsCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZSteps_Create(BZSteps *steps)
{
	NullCheck(steps);
	TRY {
		*steps=NULL;
		*steps=new Steps;
	} CATCH;
}

void BZP_API BZSteps_Destroy(BZSteps steps)
{
	delete steps;
}

BZPERROR BZP_API BZSteps_AddPath(BZSteps steps,const BZPath path,int part)
{
	NullCheck(steps);
	TRY {
		steps->AddPath(path,part);
	} CATCH;
}

BZPERROR BZP_API BZSteps_SetResolution(BZSteps steps,double resolution)
{
	NullCheck(steps);
	TRY {
		steps->SetResolution(resolution);
	} CATCH;
}

BZPERROR BZP_API BZSteps_SetOption(BZSteps steps,int option)
{
	NullCheck(steps);
	TRY {
		steps->SetOption(option);
	} CATCH;
}

BZPERROR BZP_API BZSteps_SetInterval(BZSteps steps,double interval)
{
	NullCheck(steps);
	TRY {
		steps->SetInterval(interval);
	} CATCH;
}

BZPERROR BZP_API BZSteps_NextPoint(BZSteps steps,double *x,double *y)
{
	NullCheck(steps);
	TRY {
		bool haveNext=steps->NextPoint(x,y);
		if(!haveNext) {
			error=BZPERROR_STEPS_NO_POINT;
		}
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END
