#include "prefix.h"

#include "ctool.h"
#include "cerror.h"
#include "toolholder.h"

/*************************************************

	ToolHolderCɂĂяo

**************************************************/

BZP_NAMESPACE_START

BZP_EXTERN_C_START

BZPERROR BZP_API BZTool_Create(BZTool *tool)
{
	NullCheck(tool);
	TRY {
		*tool=NULL;
		*tool=new ToolHolder;
	} CATCH;
}

void BZP_API BZTool_Destroy(BZTool tool)
{
	delete tool;
}

BZPERROR BZP_API BZTool_Entry(BZTool tool,EVENT event
	,BZPath path,BZGraph graph,POINT point,int key)
{
	NullCheck(tool);
	TRY {
		tool->Entry(event,path,graph,point,key);
	} CATCH;
}

BZPERROR BZP_API BZTool_CanStop(const BZTool tool,BOOL *canStop)
{
	NullCheck(tool);
	NullCheck(canStop);
	TRY {
		*canStop=tool->CanStop();
	} CATCH;
}

BZPERROR BZP_API BZTool_IsOperating(const BZTool tool,BOOL *isOperating)
{
	NullCheck(tool);
	NullCheck(isOperating);
	TRY {
		*isOperating=tool->IsOperating();
	} CATCH;
}

BZPERROR BZP_API BZTool_IsCapturing(const BZTool tool,BOOL *isCapturing)
{
	NullCheck(tool);
	NullCheck(isCapturing);
	TRY {
		*isCapturing=tool->IsCapturing();
	} CATCH;
}

BZPERROR BZP_API BZTool_GetCondition(const BZTool tool,int *condition)
{
	NullCheck(tool);
	NullCheck(condition);
	TRY {
		*condition=tool->GetCondition();
	} CATCH;
}

BZPERROR BZP_API BZTool_GetCurrentIndex(const BZTool tool,int *currentIndex)
{
	NullCheck(tool);
	NullCheck(currentIndex);
	TRY {
		*currentIndex=tool->GetCurrentIndex();
	} CATCH;
}

BZPERROR BZP_API BZTool_SelectTool(BZTool tool
	,int index,BZPath path,BZGraph graph)
{
	NullCheck(tool);
	TRY {
		tool->SelectTool(index,path,graph);
	} CATCH;
}

BZPERROR BZP_API BZTool_Cancel(BZTool tool,BZPath path
		,BZGraph graph)
{
	NullCheck(tool);
	TRY {
		tool->Cancel(path,graph);
	} CATCH;
}

BZPERROR BZP_API BZTool_SetToolTable(BZTool tool,const TOOLTABLE *toolTable,int count)
{
	NullCheck(tool);
	TRY {
		tool->SetToolTable(toolTable,count);
	} CATCH;
}

BZPERROR BZP_API BZTool_DidModify(BZTool tool,BOOL *didModify)
{
	NullCheck(tool);
	NullCheck(didModify);
	TRY {
		*didModify=tool->DidModify();
	} CATCH;
}

BZPERROR BZP_API BZTool_ClearModifiedFlag(BZTool tool)
{
	NullCheck(tool);
	TRY {
		tool->ClearModifiedFlag();
	} CATCH;
}

BZPERROR BZP_API BZTool_GetToolOption(BZTool tool,int lowBit,int hiBit)
{
	NullCheck(tool);
	TRY {
		tool->GetToolOption(lowBit,hiBit);
	} CATCH;
}

BZP_EXTERN_C_END

BZP_NAMESPACE_END

