#ifndef BZP_FILL_H
#define BZP_FILL_H

#include "site.h"

#ifdef __cplusplus
#include <memory>
#endif

/*************************************************

	̈hԂ

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FillMember;
class Knot;
class Curve;
class Path;
class FPoint;
class Bezier;


enum OPTIONS_FILL
{
	FILL_NOT_FILL_OPEN_CURVE=1,	/*JhԂȂ*/
};

class Fill
{
public:
	Fill();
	~Fill() throw();

	void AddPath(const Path *path,int part);
	void SetAntiAliasing(int antiAliasing);
	void SetOption(int option);

	void ScanLine(int left,int y,double *buffer,int size);
protected:
	void ClearBuffer(double *buffer,int size);
	void ResolveCurves(int y);
	bool DoesCurvePassLine(int y,const Curve *curve);
	void ResolveCurve(const Curve *curve);
	void ResolveSegment(const Knot *knotA,const Knot *knotB);
	void ResolveSegment(const FPoint &pointA,const FPoint &pointB);
	void FillBuffer(int left,int y,double *buffer,int size);
	void DisposePreviousLine(int y);
	void ReduceLine(unsigned char *buffer,int size);
	bool DoesDrawOpenCurve() const;

private:
	void SubResolveSegment(Bezier *bezier);
	void SubFillBuffer(int left,double start,double end,double *buffer,int size);

	std::auto_ptr<FillMember> m_m;

	int m_antiAliasing;	/*A`GAVO̔{*/
	int m_option;	/*IvVJ`*/
#if !defined(NDEBUG) || defined(BZP_THROW_BAD_PARAMETER)
	bool m_startScan;
#endif
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
