#ifndef BZP_FINDRESULT_H
#define BZP_FINDRESULT_H

#include "site.h"

#ifdef __cplusplus
#include <assert.h>

#include "part.h"
#include "index.h"
#include "fpoint.h"
#include "partmask.h"

#endif

/*************************************************

	Tʂ̕ێƔ

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FindResult
{
public:
	/**/
	void Initialize();

	FindResult() {
		Initialize();
	}

	/*TʒuɓĂRXgN^*/
	FindResult(const FPoint & point) {
		m_point=point;
		Initialize();
	}

	/*Ȃ*/
	bool IsNoPart() const
	{
		return BZP_PARTMASK::IsNoPart(m_part);
	}

	/*Tʂpڂ̒ʉߓ__ł邩*/
	bool IsKnot() const
	{
		return BZP_PARTMASK::ContainKnot(m_part);
	}

	/*Tʂʉߓ_ł邩*/
	bool IsAnchor() const
	{
		return BZP_PARTMASK::ContainAnchor(m_part);
	}

	/*Tʂn_ł邩*/
	bool IsFirstAnchor() const
	{
		return BZP_PARTMASK::ContainFirstAnchor(m_part);
	}

	/*TʂԂ̒ʉߓ_ł邩*/
	bool IsJointAnchor() const
	{
		return BZP_PARTMASK::ContainJointAnchor(m_part);
	}

	/*TʂI_ł邩*/
	bool IsLastAnchor() const
	{
		return BZP_PARTMASK::ContainLastAnchor(m_part);
	}

	/*Tʂ_ł邩*/
	bool IsControl() const
	{
		return BZP_PARTMASK::ContainControl(m_part);
	}

	/*TʂO̕_*/
	bool IsForwardControl() const
	{
		return BZP_PARTMASK::ContainForwardControl(m_part);
	}

	/*Tʂ̕_*/
	bool IsBackControl() const
	{
		return BZP_PARTMASK::ContainBackControl(m_part);
	}

	/*Tʂł邩*/
	bool IsCurve() const
	{
		return BZP_PARTMASK::ContainCurve(m_part);
	}

	/*TʂTuO[vł邩*/
	bool IsSubGroup() const
	{
		return BZP_PARTMASK::ContainSubGroup(m_part);
	}

	/*Tʂ̖[ł邩*/
	bool IsEndAnchor() const
	{
		return BZP_PARTMASK::ContainEndAnchor(m_part);
	}

	/*Tʂ̕ʂIĂ邩*/
	bool IsSelected() const
	{
		return BZP_PARTMASK::IsSelectedPart(m_part);
	}

	/*Tʂ̐Ă邩*/
	bool IsClosed() const
	{
		return BZP_PARTMASK::IsClosedCurve(m_part);
	}

	/*pڂ_ȐɂȂĂ邩*/
	bool IsCurved() const
	{
		return BZP_PARTMASK::IsCurvedKnot(m_part);
	}

	/*AĂ邩*/
	bool IsLinked() const
	{
		return BZP_PARTMASK::IsLinkedKnot(m_part);
	}

	/*Tʂ̂܂ܕԂ*/
	int GetPartWithCondition() const
	{
		return m_part;
	}

	/*Tʂ̕ʂ݂̂Ԃ*/
	int GetPart() const
	{
		return BZP_PARTMASK::MaskPart(m_part);
	}

	/*܂ȕʂԂ*/
	int GeneralPart() const
	{
		return BZP_PARTMASK::GeneralPart(m_part);
	}

	/*Tʂɕʂݒ*/
	void SetPart(int part)
	{
		assert((part&~PART_ALL)==0);
		m_part&=~PART_ALL;
		m_part|=part;
	}

	/*TʂȂɐݒ肷*/
	void ClearPart()
	{
		m_part=PART_NONE;
	}

	/*TʂɑIԂݒ*/
	void SetSelect(bool isSelected=true);

	/*Tʂɐ̊Jݒ*/
	void SetClose(bool isClosed);

	/*pڂ_ȐɂȂĂ邩ݒ肷*/
	void SetCurve(bool isCurved);

	/*AĂ邩ݒ肷*/
	void SetLink(bool isLinked);

	/*TʂɃTuO[v̔ԍݒ*/
	void SetSubGroupIndex(int index)
	{
		m_subGroupIndex=index;
	}

	/*Tʂ̃TuO[v̔ԍԂ*/
	int GetSubGroupIndex() const
	{
		return m_subGroupIndex;
	}

	/*Tʂɐ̔ԍݒ*/
	void SetCurveIndex(int index)
	{
		m_curveIndex=index;
	}

	/*Tʂ̐̔ԍԂ*/
	int GetCurveIndex() const
	{
		return m_curveIndex;
	}

	/*TʂɌpڂ̔ԍݒ
	̏ꍇ͂̐̏ԍ̌̕pڂ̔ԍ*/
	void SetKnotIndex(int index)
	{
		m_knotIndex=index;
	}

	/*Tʂ̌pڂ̔ԍԂ
	̏ꍇ͂̐̏ԍ̂ق̌pڂ̔ԍ*/
	int GetKnotIndex() const
	{
		return m_knotIndex;
	}

	/*̈ʒuݒ*/
	void SetCurve_t(double t)
	{
		m_curve_t=t;
	}

	/*̈ʒuԂ*/
	double GetCurve_t() const
	{
		return m_curve_t;
	}

	/*Iꂽ̏̌pڂݒ*/
	void SetKnotOnSelectedCurve(bool isSelected)
	{
		m_knotOnSelectedCurve=isSelected;
	}

	/*Iꂽ̏̌pڂ*/
	bool IsKnotOnSelectedCurve() const
	{
		return m_knotOnSelectedCurve;
	}

	/*TWݒ*/
	void SetPoint(const FPoint & point)
	{
		m_point=point;
	}

	/*TWԂ*/
	FPoint GetPoint() const
	{
		return m_point;
	}

	/*TȂpڂݒ*/
	void SetIgnoreKnot(int knotIndex,int curveIndex)
	{
		m_ignoreKnot=knotIndex;
		m_ignoreCurve=curveIndex;
	}

	/*TȂpڂ*/
	bool IsIgnoreKnot(int knotIndex,int curveIndex) const
	{
		return ((curveIndex==m_ignoreCurve)
			&&(knotIndex==m_ignoreKnot));
	}

private:
	FPoint m_point;	/*TW*/

	int m_part;	/*pX̕ʂƑIԂƊJ*/
	int m_subGroupIndex;	/*TuO[v̔ԍ*/
	int m_curveIndex;	/*̔ԍ*/
	int m_knotIndex;	/*pڂ̔ԍ*/
	double m_curve_t;	/*̈ʒu*/
	bool m_knotOnSelectedCurve;	/*IĂ̏̓_*/

	/*TΏۂOp*/
	int m_ignoreCurve;
	int m_ignoreKnot;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif