#ifndef BZP_FPOINT_H
#define BZP_FPOINT_H

#include "site.h"

#ifdef __cplusplus
#include <windows.h>
#include "fpointbase.h"
#endif

/*************************************************

	_ł̍WNX̒`

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class Rect;
class FRect;

class FPoint : public FPOINT
{
public:
	FPoint()
	{
	}
	~FPoint() throw();
	FPoint(double x,double y);
	FPoint(const FPoint & point);
	FPoint(POINT pointInt);
	FPoint(const FPOINT &point);
	FPoint operator =(POINT pointInt);
	FPoint operator =(const FPoint &point);
	FPoint operator =(const FPOINT &point);
	FPoint Mapping(const Rect &fromRect,const Rect &toRect) const;	/*Wϊ*/
	FPoint operator -(const FPoint & point) const;
	FPoint operator +(const FPoint & point) const;
	FPoint operator -=(const FPoint & point);
	FPoint operator +=(const FPoint & point);
	FPoint operator *(double v) const;
	FPoint operator /(double v) const;
	FPoint operator -() const;
	bool operator !=(const FPoint & point) const;
	bool operator ==(const FPoint & point) const;
	FPoint TPoint(const FPoint & pointB,double t) const;
	void TPoint(const FPoint & pointA,const FPoint & pointB,double t);
	FPoint Center(const FPoint & pointB) const;
	FPoint LeavePoint(const FPoint & pointB,double length) const;
	operator POINT() const;
	double Distance(const FPoint & point) const;
	bool IsInArea(const FPoint & target,int area) const;
	bool IsInRect(const FRect &rect) const;
	void FixAngle(const FPoint & root);
	FPoint Roll(double angle) const;
	FPoint OppositePoint(const FPoint &point) const;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif