#ifndef BZP_GDIOBJECT_H
#define BZP_GDIOBJECT_H

#include "site.h"

#ifdef __cplusplus
#include <windows.h>
#endif

/*************************************************

	GDIIuWFNgL

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class GdiObject;

/*foCXReLXgǗNX*/
class GdiDC
{
public:
	GdiDC();
	GdiDC(HDC hDC);
	~GdiDC() throw();
	HDC Get() const;
	void Attach(HDC hDC);
	void Rent(HDC hDC);
	void Delete() throw();
	void SelectObject(GdiObject *object);
	void SelectStockObject(DWORD type,HGDIOBJ object);
	void DeselectObject(DWORD type) throw();
private:
	HDC m_hDC;

	GdiObject *m_penObject;
	GdiObject *m_brushObject;
	GdiObject *m_bitmapObject;

	HGDIOBJ m_oldPen;
	HGDIOBJ m_oldBrush;
	HGDIOBJ m_oldBitmap;

	bool m_autoDelete;
};

/*yuVȂǂGDIIuWFNgǗNX*/
class GdiObject
{
public:
	GdiObject();
	GdiObject(DWORD type,HGDIOBJ object);
	GdiObject(DWORD type,int number);
	~GdiObject() throw();
	void Attach(DWORD type,HGDIOBJ object);
	void SetStockObject(DWORD type,int number);
	HGDIOBJ Get() const;
	void Delete() throw();
	void Select(GdiDC *dc);
	void Deselect() throw();
	DWORD Type() const throw();
	
	operator HBRUSH();
	operator HPEN();
	operator HBITMAP();
	operator HRGN();
protected:
	GdiDC *m_dc;
	HGDIOBJ m_object;
	DWORD m_type;
};

void GdiResourceLeakCheck();

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
