#ifndef BZP_GRAPH_H
#define BZP_GRAPH_H

#include "site.h"

#ifdef __cplusplus
#include <windows.h>
#include <memory>
#endif

/*************************************************

	\Wϊ̃NX

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class FPoint;
class GdiDC;
class GdiObject;
class Rect;
class FRect;
class GdiDC;
enum PARTSSIZE;

class GraphMember;

class Graph  
{
public:
	Graph();
	~Graph() throw();

	bool IsInUse() const;	/*ŕ\ĂŒɏ͂łȂ*/

	/*ݒ*/
	void SetViewDC(HDC hDC);	/*\ʂ̃foCXReLXg*/
	void SetViewRect(const Rect &rect);	/*\W\`̐ݒ*/
	void SetViewRect(const RECT &rect);
	void SetBoundRect(const Rect &rect); /*W\`̐ݒ*/
	void SetBoundRect(const RECT &rect);
	void SetColor(COLORREF color);	/*F̐ݒ*/
	void SetInvertColor(COLORREF color); /*\F𔽓]Đݒ*/
	void SetPartsSize(PARTSSIZE parts,int size);	/*iT͈͂̑傫ݒ*/
	int GetPartsSize(PARTSSIZE parts) const; /*iT͈͂̑傫𓾂*/

	bool IsPointInView(POINT point) const;	/*Wr[̕\̈ɂ邩*/

	HDC GetViewDC() const;	/*\ʂ̃foCXReLXg𓾂*/
	HDC GetBitmapDC() const;	/*rbg}bṽfoCXReLXg*/

	void SetDrawMode(int mode);	/*\̃IvV̐ݒ*/
	int GetDrawMode() const; /*\IvV𓾂*/

	/*obt@*/
	static void DestroyBitmap();	/*rbg}bv̍폜*/
	static void DestroyStaticObjects(); /*ÓIIuWFNg̍폜*/

	/*ʂւ̕\*/
	void DrawDifference();	/*ύXO̍\*/
	void DrawAll();	/*SĂ\*/

	/*pXNX`悷邽߂̊֐*/
	void DrawCurve(const FPoint & anchorA,const FPoint & forwardA,const FPoint & backB,const FPoint & anchorB) const;
	void DrawAnchor(const FPoint & anchor,bool isSelected) const;
	void DrawControlHandle(const FPoint & anchor,const FPoint & control) const;
	void DrawArrowControl(const FPoint &anchor,const FPoint &control) const;
	void DrawSingleKnot(const FPoint & anchor) const;
	void DrawSelectShape(const FRect &rect,bool isCircle,bool dot) const;

	void PrepareBeforeBitmap();
	void PrepareAfterBitmap();
	void CancelDraw() throw();

	POINT BoundToView(const FPoint & boundpoint) const;	/*WW\Wɕϊ*/
	FPoint ViewToBound(POINT viewpoint) const;	/*W\WWɕϊ*/
	void BoundToView(Rect *viewRect,const FRect &boundRect) const;
	FPoint GetCurveArea() const;	/*̒T͈͂boundRectɍ킹*/

	bool DoesDrawKnot() const;
	bool DoesDrawUnselected() const;
	bool DoesDrawArrowControl() const;
	bool DoesDrawMargin() const;
	bool DoesDraw() const;
protected:
private:
	void AllocateBuffer();	/*ݒɂĕKvȑ傫̃rbg}bv*/

	void DeleteDrawDC();
	void DeleteBeforeDC();
	void CreateMemoryDC(GdiDC *dc,GdiObject *bitmap);
	void CalcClipRect(Rect *rect) const;

	const std::auto_ptr<GraphMember> m_m;

	/*`ݒ*/
	COLORREF m_color;	/*`FŔ]*/

	int m_drawMode;	/*`̐ݒ*/

	std::auto_ptr<GdiDC> m_drawDC;	/*݂̏Ԃ`悷邽߂̃foCXReLXg*/
	std::auto_ptr<GdiDC> m_beforeDC;	/*ύXŐL^ێfoCXReLXg*/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
