#include "prefix.h"

#include <windows.h>

#include "keyboard.h"
#include "runtimeconfig.h"

/*************************************************

	L[͂̔

**************************************************/

BZP_NAMESPACE_START

BZP_KEYBOARD_START

bool GetKeyState(int key)
{
	return (::GetKeyState(key)&0x8000)!=0;
}

//IsPushedKeyŔ肷邽߂̒lɕϊ
static int AppendShiftKeyFlags(int key)
{
	switch(key) {
	case VK_SHIFT:
		key=KEY_SHIFT;
		break;

	case VK_CONTROL:
		key=KEY_CONTROL;
		break;

	case VK_MENU:
		key=KEY_ALT;
		break;
	}

	if(key!=KEY_SHIFT && GetKeyState(VK_SHIFT)) {
		key|=KEY_SHIFT;
	}
	if(key!=KEY_CONTROL && GetKeyState(VK_CONTROL)) {
		key|=KEY_CONTROL;
	}
	if(key!=KEY_ALT && GetKeyState(VK_MENU)) {
		key|=KEY_ALT;
	}

	return key;
}

//w肵L[͐ݒ肳ꂽL[
bool IsPushedKey(CONFIG_INT config,int key)
{
	int confkey=BZP_CONFIG::GetConfigInt(config);
	if(confkey==KEY_IGNORE) {
		return false;
	}
	return confkey==AppendShiftKeyFlags(key);
}

static bool CheckShiftKey(int configKey,int shiftKey,int virtualKey)
{
	bool shouldPush= (configKey&shiftKey)!=0;
	bool pushed= GetKeyState(virtualKey);

	return (shouldPush && pushed) || (!shouldPush && !pushed);
}

//ݒ肳ꂽL[Ă邩
bool IsPushingKey(CONFIG_INT config)
{
	int configKey=BZP_CONFIG::GetConfigInt(config);
	if(configKey==KEY_IGNORE) {
		return false;
	}
	int virtualKey=configKey&(KEY_SHIFT_MULTIPLE-1);

	if(virtualKey!=0 && !GetKeyState(virtualKey)) {
		return false;
	}

	if(!CheckShiftKey(configKey,KEY_SHIFT,VK_SHIFT)) {
		return false;
	}
	if(!CheckShiftKey(configKey,KEY_CONTROL,VK_CONTROL)) {
		return false;
	}
	if(!CheckShiftKey(configKey,KEY_ALT,VK_MENU)) {
		return false;
	}
	return true;
}

BZP_KEYBOARD_END

BZP_NAMESPACE_END
