#ifndef BZP_KNOT_H
#define BZP_KNOT_H

#include "site.h"

#ifdef __cplusplus
#include <memory>
#endif

/*************************************************

	Ȑ̌pڂ̃NX̒`

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class Graph;
class FindResult;
class Data;
class FRect;
class FPoint;
class PathTo;
class ToPath;
class TRANSFORM;
enum SELECTMODE;
enum KNOTMODE;

class KnotMember;

class Knot
{
public:
	Knot();
	~Knot() throw();

	int GetMode() const;
	bool IsSelected() const;
	void Select(bool isSelected=true);
	bool IsLinked() const;
	void Link(bool isLinked=true);
	bool IsCurved(int part) const;
	FPoint GetPoint(int part) const;
	void Curve(bool isCurved,int part);

	void DrawControlHandles(const Graph *graph,bool isPrevSelected,bool isNextSelected) const;
	void DrawSingleKnot(const Graph *graph) const;
	void DrawAnchor(const Graph *graph) const;
	void DrawAnchor(const Graph *graph,bool isSelected) const;

	bool Find(FindResult *findResult,const Graph *graph,int mask,int anchorPart,bool isPrevSeleted,bool isNextSelected) const;

	void MovePoint(const FPoint & point,int part);
	void MoveRel(const FPoint & pointRel);
	void SetPoint(const FPoint & point,int part);
	void MoveWControls(const FPoint & point,bool grippedForward);

	void Copy(const Knot *srcKnot);
	void Reverse();

	bool IsAnchorInRect(const FRect &rect) const;
	void SelectBox(SELECTMODE mode,const FRect &rect);

	void PathToData(PathTo *const converter) const;
	void DataToPath(ToPath *const converter);

	void GetOuterRect(FRect *rect,double precision) const;
	void Transform(const TRANSFORM &transform);
protected:
	void DeleteControl(bool deleteForward);
	void MoveForwardControl(const FPoint & point);
	void MoveBackControl(const FPoint & point);
	void CalcControlLength();

private:
	const std::auto_ptr<KnotMember> m_m;
	int m_mode;	/*pڂ̏*/
	
	/*Ɨp*/
	/*̒덷ŏk܂Ȃ悤ɂ邽*/
	double m_forwardLength;	
	double m_backLength;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif