#ifndef BZP_PARTMASK_H
#define BZP_PARTMASK_H

#include "site.h"

#ifdef __cplusplus
#include "part.h"
#endif

/*************************************************

	ʂ̍i

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

#ifdef BZP_HAS_NAMESPACE
# define BZP_PARTMASK BZPNAME::partmask
# define BZP_PARTMASK_START namespace partmask {
# define BZP_PARTMASK_END }
# define BZP_PARTMASK_USING using namespace partmask;
#else
# define BZP_PARTMASK
# define BZP_PARTMASK_START
# define BZP_PARTMASK_END
# define BZP_PARTMASK_USING
#endif

BZP_PARTMASK_START

/*ԈȊO̕ʂmaskɍi荞*/
inline const
 int MaskExceptCondition(int part,int mask)
{
	return part&((~PART_ALL)|mask);
}

/*Ԃɍi荞*/
inline const
 int MaskCondition(int part)
{
	return part&(~PART_ALL);
}

/*ʂ݂̂Ԃ*/
inline const
 int MaskPart(int part)
{
	return part&PART_ALL;
}

/*mask̒T}XNpڂ̒Tɍi荞*/
inline const 
 int MaskKnot(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_KNOT);
}

/*_ɍi荞*/
inline const
 int MaskControl(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_CONTROL);
}

/*O̕_ɍi荞*/
inline const
 int MaskForwardControl(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_FORWARDCONTROL);
}

/*̕_ɍi荞*/
inline const
 int MaskBackControl(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_BACKCONTROL);
}

/*ʉߓ_ɍi荞*/
inline const
 int MaskAnchor(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_ANCHOR);
}

/*n_ɍi荞*/
inline const
 int MaskFirstAnchor(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_FIRSTANCHOR);
}

/*I_ɍi荞*/
inline const
 int MaskLastAnchor(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_LASTANCHOR);
}

/*Ԃ̒ʉߓ_ɍi荞*/
inline const
 int MaskJointAnchor(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_JOINTANCHOR);
}

/*Ɩ[ɍi荞*/
inline const
 int MaskUnselectedCurve(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_CURVE|PART_ENDANCHOR);
}

/*ɍi荞*/
inline const
 int MaskCurve(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_CURVE);
}

/*TuO[vɍi荞*/
inline const
 int MaskSubGroup(int part=PART_ALL)
{
	return MaskExceptCondition(part,PART_SUBGROUP);
}

/*ʂȂ*/
inline const
 bool IsNoPart(int part)
{
	return (part&PART_ALL)==PART_NONE;
}

/*ԂtɂȂĂ邩𒲂ׂ鉺*/
inline const
 bool IsOpposite(int part,bool flag,int onPart,int offPart)
{
	return ((part&onPart)!=0 && !flag)
		||((part&offPart)!=0 && flag);
}

/*ʂ̑IԂƒTΏۂtɂȂĂ邩*/
inline const
 bool IsSelectedOpposite(int part,bool isSelected)
{
	return IsOpposite(part,isSelected,PART_SELECTED,PART_UNSELECTED);
}

/*̕ԂƒTΏۂtɂȂĂ邩*/
inline const
 bool IsClosedOpposite(int part,bool isClosed)
{
	return IsOpposite(part,isClosed,PART_CLOSED,PART_OPENED);
}

/*ȐɂȂĂԂƒTΏۂtɂȂĂ邩*/
inline const
 bool IsCurvedOpposite(int part,bool isCurved)
{
	return IsOpposite(part,isCurved,PART_CURVED,PART_STRAIGHT);
}

/*ȂĂԂƒTΏۂtɂȂĂ邩*/
inline const
 bool IsLinkedOpposite(int part,bool isLinked)
{
	return IsOpposite(part,isLinked,PART_LINKED,PART_UNLINKED);
}

/*ʂɌpڂ܂܂Ă邩*/
inline const
 bool ContainKnot(int part)
{
	return (part&PART_KNOT)!=PART_NONE;
}

/*ʂɒʉߓ_܂܂Ă邩*/
inline const
 bool ContainAnchor(int part)
{
	return (part&PART_ANCHOR)!=PART_NONE;
}

/*ʂɐ̖[܂܂Ă邩*/
inline const
 bool ContainEndAnchor(int part)
{
	return (part&PART_ENDANCHOR)!=PART_NONE;
}

/*ʂɒԂ̌pڂ܂܂Ă邩*/
inline const
 bool ContainJointAnchor(int part)
{
	return (part&PART_JOINTANCHOR)!=PART_NONE;
}

/*ʂɍŏ̌pڂ܂܂Ă邩*/
inline const
 bool ContainFirstAnchor(int part)
{
	return (part&PART_FIRSTANCHOR)!=PART_NONE;
}

/*ʂɍŌ̌pڂ܂܂Ă邩*/
inline const
 bool ContainLastAnchor(int part)
{
	return (part&PART_LASTANCHOR)!=PART_NONE;
}

/*ʂɕ_܂܂Ă邩*/
inline const
 bool ContainControl(int part)
{
	return (part&PART_CONTROL)!=PART_NONE;
}

/*ʂɑO̕_܂܂Ă邩*/
inline const
 bool ContainForwardControl(int part)
{
	return (part&PART_FORWARDCONTROL)!=PART_NONE;
}

/*ʂɌ̕_܂܂Ă邩*/
inline const
 bool ContainBackControl(int part)
{
	return (part&PART_BACKCONTROL)!=PART_NONE;
}

/*ʂɐ܂܂Ă邩*/
inline const
 bool ContainCurve(int part)
{
	return (part&PART_CURVE)!=PART_NONE;
}

/*ʂɃTuO[v܂܂Ă邩*/
inline const
 bool ContainSubGroup(int part)
{
	return (part&PART_SUBGROUP)!=PART_NONE;
}

/*ʂIĂ邩*/
inline const
 bool IsSelectedPart(int part)
{
	return (part&PART_SELECTED)!=0;
}

/*Ă邩*/
inline const
 bool IsClosedCurve(int part)
{
	return (part&PART_CLOSED)!=0;
}

/*pڂȐɂȂĂ邩*/
inline const
 bool IsCurvedKnot(int part)
{
	return (part&PART_CURVED)!=0;
}

/*ȂĂ邩*/
inline const
 bool IsLinkedKnot(int part)
{
	return (part&PART_LINKED)!=0;
} 

/*܂ȕʂԂ*/
const int GeneralPart(int part);

BZP_PARTMASK_END

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif