#ifndef BZP_PATH_H
#define BZP_PATH_H

#include "site.h"

#ifdef __cplusplus
#include "group.h"

#include <windows.h>
#endif

/*************************************************

	pX̃NX
	GrouppĂGroup̊֐g

  			SubGroup
			p L
	Path  Group
		p L
			Curve
			 L
			Knot

**************************************************/

BZP_NAMESPACE_START

#ifdef __cplusplus

class Graph;
class Rect;
class Converter;
class FRect;

class Path : protected Group
{
public:
	Path();
	~Path() throw();

	Path(const Path &source);
	void Copy(const Path *source);
	const Path &operator = (const Path &source);

	void SetBoundRect(const Rect &rect);	/*W`̐ݒ*/
	void SetBoundRect(const RECT &rect); 
	void GetBoundRect(RECT *rect) const;

	void SelectAll(bool isSelected);	/*SĂ̐ƃTuO[vI*/

	/*pX͂ދ`𓾂*/
	void GetOuterRect(RECT *rect,int part,double precision=1.0) const;
	void GetOuterRect(Rect *rect,int part,double precision=1.0) const;
	void GetOuterRect(FRect *rect,int part,double precision=1.0) const;

	void Move(double x,double y);	/*sړ*/
	void Move(FPoint point); /*sړ*/
	void HReverse();	/*E]*/
	void VReverse();	/*㉺]*/

	void PathToData(PathTo *const converter,int part) const;
	void DataToPath(ToPath *const converter);
	void SelectBox(SELECTMODE mode,const FRect &rect);
	bool Find(FindResult *findResult,const Graph *graph,int mask) const;
	void Draw(const Graph *graph) const;
	void Append(const Path *path);
protected:

private:
	const std::auto_ptr<Rect> m_boundRect;


public:	/*GroupNX̊֐*/
	using Group::CurveCount;
	using Group::SubGroupCount;
	using Group::IsEmpty;

	using Group::Destroy;
	using Group::InsertKnot;
	using Group::AddEndKnot;
	using Group::KnotCount;
	using Group::SelectKnot;
	using Group::IsSelectedKnot;
	using Group::MoveSelectedKnots;
	using Group::DeleteKnot;
	using Group::LinkKnot;
	using Group::CurveKnot;
	using Group::SymbolizeKnotIndex;
	using Group::CopyKnot;
	using Group::CopyKnotTo;
	using Group::IsCurved;
	using Group::SelectedKnotCount;

	using Group::GetPoint;
	using Group::MovePoint;
	using Group::SetPoint;
	using Group::MoveWControls;

	using Group::NewCurve;
	using Group::DeleteCurve;
	using Group::Chain;

	using Group::SelectCurve;
	using Group::IsSelectedCurve;
	
	using Group::MoveCurve;
	using Group::IsSameCurve;
	using Group::IsClosedCurve;
	using Group::CloseCurve;
	using Group::SelectedCurveCount;

	using Group::SelectSubGroup;
	using Group::IsSelectedSubGroup;
	using Group::DeleteSubGroup;
	using Group::MoveSelectedSubGroups;
	using Group::SelectedSubGroupCount;

	using Group::ExtractCurve;
	using Group::PutInGroup;
	using Group::Ungroup;
	using Group::Transform;

	using Group::CutCurvePoint;
	using Group::CutCurveSegment;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif