#ifndef BZP_SITE_H
#define BZP_SITE_H

#include "siteconfig.h"

/*************************************************

	RpCˑ

**************************************************/

/*RpC̐ݒ

BZP_USE_PRECOMPILE_HEADER vRpCwb_[g
BZP_NEW_DONT_THROW@newsƂɗO𓊂Ȃ
BZP_HAS_NAMESPACE OԂg
BZP_NO_LOOP_SCOPE	for̃XR[vʂɂȂĂȂ
BZP_BAD_ALLOC_EXCEPTION newO𓊂ȂꍇɃCu[ɓO
BZP_USE_EXCEPTION	O顃Cu[RpCƂɂ͗OȂƂ܂Ȃ
		Cu[N鑤ł͗O͕Kvł͂Ȃ
BZP_ATAN_XY	atan2̈x,yŌĂяo
BZP_API ČĂяoDLL̃GNX|[g֐ɂ
									*/

#if _MSC_VER	/*Microsoft C++*/
# define BZP_USE_PRECOMPILE_HEADER
# define BZP_NEW_DONT_THROW
# define BZP_HAS_NAMESPACE
# define BZP_NO_LOOP_SCOPE
# define BZP_BAD_ALLOC_EXCEPTION std::bad_alloc
# define BZP_ATAN_XY(x,y) atan2(y,x)
# if defined(_CPPUNWIND)
#  define BZP_USE_EXCEPTION
# endif
# ifdef BZP_DLL
#  ifdef BZP_IMPORT
#   define BZP_API __declspec(dllimport) __stdcall
#  else
#   define BZP_API __declspec(dllexport) __stdcall
#  endif
# else
#  define BZP_API
# endif

#elif defined(__BORLANDC__)	/*Borland C++*/
# define BZP_USE_PRECOMPILE_HEADER
# define BZP_HAS_NAMESPACE
# define BZP_ATAN_XY(x,y) ((x!=0||y!=0)?atan2(y,x):0)
# if defined(_CPPUNWIND)
#  define BZP_USE_EXCEPTION
# endif
# ifdef BZP_DLL
#  ifdef BZP_IMPORT
#   define BZP_API __declspec(dllimport) __stdcall
#  else
#   define BZP_API __declspec(dllexport) __stdcall
#  endif
# else
#  define BZP_API
# endif

#else
# error RpC[Ƃ̐ݒĂ
#endif


/*STL̐ݒ*************/

#if defined(BZP_STL_STLPORT)	/*STLPort*/
# define BZP_AUTO_PTR_HAS_RESET
# ifndef NDEBUG
#  define _STLP_DEBUG 1
# endif

#elif defined(BZP_STL_SGI)		/*SGI*/
# define BZP_AUTO_PTR_HAS_RESET

#elif defined(BZP_STL_BCC)		/*Borland*/
# define BZP_AUTO_PTR_HAS_RESET

#elif defined(BZP_STL_MSC)		/*Microsoft C++*/

#endif

/*************}N**********/

/*DLL̏ꍇ͈̊ԈႢ̂ƂɃG[Ԃ*/
#ifdef BZP_DLL
# define BZP_THROW_BAD_PARAMETER
#endif

/*AvP[V̈֐Ăяo̊ԈႢɗOȂ邩AT[go*/
#ifdef BZP_THROW_BAD_PARAMETER
# define BZP_PARAMETER_ERROR(exp,error) { if(!(exp)) throw Exception(error); }
#else 
# define BZP_PARAMETER_ERROR(exp,error) assert(exp)
#endif

/*C̊֐̎n܂ƏI*/
#if defined(__cplusplus)
# define BZP_EXTERN_C_START extern "C" {
# define BZP_EXTERN_C_END }
#else 
# define BZP_EXTERN_C_START
# define BZP_EXTERN_C_END
#endif

/*newO𓊂ȂꍇɃCu[őɓO*/
#ifndef BZP_BAD_ALLOC_EXCEPTION
# define BZP_BAD_ALLOC_EXCEPTION std::bad_alloc
#endif

/*RpCOȂꍇɂ̓RpCG[*/
#ifndef BZP_USE_EXCEPTION
# ifndef BZP_IMPORT
#  error OLɂĂ
# endif
#endif

/*STLgĂꍇɂłx\Ȃ*/
#ifdef BZP_DISABLE_STL_WARNING
# ifdef _MSC_VER
#   if defined(BZP_STL_SGI)
#    pragma warning(disable:4804)	/*bool̑召r*/

#   elif defined(BZP_STL_STLPORT)
#    pragma warning(disable:4521)	/*auto_ptr ̃Rs[RXgN^*/
#    pragma warning(disable:4522)	/*auto_ptr ̑Zq*/
#   endif
# endif
#endif	/*KɒǉĂꂽ܂*/

/*֐Ⴄꍇɋʂ̖Oɂ*/
#ifndef BZP_IMPORT
# if defined(_MSC_VER)
#  define hypot _hypot
# endif
#endif

/*newO𓊂ȂȂ烉Cu[œ}N*/
#ifdef BZP_NEW_DONT_THROW
/*ptrNULL̏ꍇbad_alloc𓊂*/
# define BZP_BAD_ALLOC_TEST(ptr)	\
	if(ptr==NULL) {	\
		throw BZP_BAD_ALLOC_EXCEPTION();	\
	}
#else
# define BZP_BAD_ALLOC_TEST(ptr)
#endif

/*for̃XR[vʂɂ*/
#ifndef BZP_IMPORT
# ifdef BZP_NO_LOOP_SCOPE
#  define FOR if(false); else for
# else
#  define FOR for
# endif
#endif

/*OԂ̃}N*/
#ifdef BZP_HAS_NAMESPACE
# define BZPNAME ::BZP_NAME
# define BZP_NAMESPACE_START namespace BZP_NAME {
# define BZP_NAMESPACE_END }
#else
# define BZPNAME
# define BZP_NAMESPACE_START
# define BZP_NAMESPACE_END
#endif

/*auto_ptrresetĂȂꍇ̂߂̃}N*/
#ifdef BZP_AUTO_PTR_HAS_RESET
#define BZP_AUTOPTR_RESET(autoptr,type,ptr) autoptr.reset(ptr)
#else
#define BZP_AUTOPTR_RESET(autoptr,type,ptr)	\
{	\
	std::auto_ptr<type> newptr(ptr);	\
	autoptr=newptr;	\
}
#endif


#endif
