#ifndef BZP_STEPS_H
#define BZP_STEPS_H

#include "site.h"

/*************************************************

	̊Ԋu̓_

**************************************************/

BZP_NAMESPACE_START

#if 0	/*肩*/

enum STEPTYPE	/*_̎*/
{
	STEPTYPE_NORMAL,	/*̑*/
	STEPTYPE_FIRST,	/*n߂̓_*/
	STEPTYPE_LAST,	/*I̓_*/
	STEPTYPE_CORNER,	/*p*/
};

/*_̏Ԃ\*/
struct tagSTEPDATA {
	FPoint point;
	double angle;
	STEPTYPE type;
};
typedef tagSTEPDATA STEPDATA;
#endif

enum OPTION_STEPS	/*IvV*/
{
	STEPS_NOT_ADJUST_CORNER=1,/*pŒ߂ȂȂĂȂpڡ*/
	STEPS_NOT_ADJUST_CLOSED=2,/*Œ߂Ȃ*/
	STEPS_NOT_ADJUST_END=4,	/*̒[Œ߂Ȃ*/
	STEPS_NOT_PUT_SINGLEKNOT=8,	/*Ǘpڂɓ_uȂ*/
};

#ifdef __cplusplus

class FPoint;
class CurvePointers;
class Path;
class Knot;
class Curve;
class PointQue;

class StepsMember;

class Steps
{
public:
	Steps();
	~Steps() throw();

	void AddPath(const Path *path,int part);
	void SetResolution(double resolution);
	void SetOption(int option);	/*IvV̐ݒ*/
	void SetInterval(double interval);	/*Ԋu̐ݒ*/

	/*_ falseȂ_Ȃ*/
	bool NextPoint(FPoint *point);
	bool NextPoint(double *x,double *y);

protected:
	void ChargeSteps();
	void ResolveSegment(PointQue *polyline,const Knot *curKnot,const Knot *nextKnot) const;
	double AssignSteps(PointQue *steps,const PointQue &polyline,double leftInterval,bool doesAdjust) const;
	double AssignStepsNotAdjust(PointQue *steps,const PointQue &polyline,double leftInterval) const;
	void AssignStepsAdjust(PointQue *steps,const PointQue &polyline) const;
	bool DoesAdjust() const;
	bool DoesAdjustCorner() const;
	bool DoesAdjustClosed() const;
	bool DoesAdjustEnd() const;
	bool DoesPutSingleKnot() const;
	int FirstCorner(const Curve *curve) const;
	double PolylineLength(const PointQue &polyline) const; 
private:
	const std::auto_ptr<StepsMember> m_m;

	int m_option;	/*IvV*/
	double m_interval; /*_Ɠ_̊Ԋu*/

	double m_polylineResolution;

	/*ChargeSteps̍Ɨp*/
	double m_intervalLeft;	/*Ԋu̗]*/
	int m_curveIndex;	/*ƒ̐*/
	int m_knotIndex;	/*ƒ̐*/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
