#ifndef BZP_TOOLBASE_H
#define BZP_TOOLBASE_H

#include "site.h"

/*************************************************

	c[̊{NX

**************************************************/

/*m_condition̒lc[Ƃɕނ邽߂̌*/
#define CONDITION_MULTIPLE 0x10000

BZP_NAMESPACE_START

#ifdef __cplusplus

class Path;
class FPoint;
class Redraw;
enum EVENT;
enum CONFIG_INT;
class Graph;

class ToolBase
{
public:
	ToolBase();
	virtual ~ToolBase() throw();

	bool SetOption(int option); /*c[IvVݒ*/
	int GetOption() const;	/*݂̃c[IvV𓾂*/
	virtual bool IsOperating() const=0;	/*쒆*/
	virtual bool IsCapturing() const=0;	/*}EXLv`[邩*/

	virtual bool CanStop() const; 	/*𒆒fł邩*/

	int GetCondition() const;	/*݂̏Ԃ𓾂*/
	void Entry(EVENT event,Path *path,Graph *graph,POINT viewpoint,int key=0);	/*Cxg*/
	void Entry(EVENT event,Path *path,Graph *graph)
	{
		POINT viewPoint={-3000,-3000};	/*EBhE̊Oł낤KȒl*/
		Entry(event,path,graph,viewPoint);
	}
	void SetModifiedFlag(bool didModify=true);
	bool DidModify() const;
	int ExtractOption(int lowBit,int hiBit) const;	/*IvV𕔕IɂƂ肾*/
protected:
	void OnDraw();
	virtual void Event(EVENT event,const FPoint & point,int key);

	bool IsPushedKey(CONFIG_INT config,int key) const;
	bool IsPushingKey(CONFIG_INT config) const;

	Path *m_path;	/*pXIuWFNg̃|C^*/
	Graph *m_graph; /*`IuWFNg̃|C^*/

	int m_option;	/*c[IvV*/
	int m_condition;	/*݂̏ڍׂȏ*/
	bool m_outsideWindow;	/*J[\EBhE̊Oɂ邩*/

	bool m_didModify;	/*pXύXꂽ*/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif

