#include "prefix.h"

#include "toolcut.h"
#include "event.h"
#include "findresult.h"
#include "part.h"
#include "path.h"
#include "fpoint.h"

#include <assert.h>

/*************************************************

	؂c[

**************************************************/

BZP_NAMESPACE_START

ToolCut::ToolCut()
{
	m_condition=COND_CUT_IDLE;
}

//쒆
bool ToolCut::IsOperating() const
{
	return false;
}

//}EXLv`[Ă邩
bool ToolCut::IsCapturing() const
{
	return false;
}

//Cxg
void ToolCut::Event(EVENT event,const FPoint & point,int)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_MOUSEMOVE:
		Idle_Move(point);
		break;

	case EVENT_LEFTDOWN:
		Start(point);
		break;
	}
}

//}EXړ
void ToolCut::Idle_Move(const FPoint & point)
{
	FindResult findResult(point);
	if(m_path->Find(&findResult,m_graph,PART_CURVE)) {
		m_condition=COND_CUT_FIND_CURVE;
	}
}

//}EX̍{^
void ToolCut::Start(const FPoint & point)
{
	FindResult findResult(point);
	if(m_path->Find(&findResult,m_graph,PART_CURVE)) {
		switch(GetCutMode()) {
		case OPTION_CUT_POINT:
			CutPoint(findResult);
			break;

		case OPTION_CUT_SEGMENT:
			CutSegment(findResult);
			break;

		default:
			assert(false);
		}
		SetModifiedFlag();
	}
}

//P_ŐؒfĐ𕪂
void ToolCut::CutPoint(const FindResult &findResult)
{
	m_path->CutCurvePoint(findResult.GetCurve_t()
		,findResult.GetKnotIndex()
		,findResult.GetCurveIndex());
}

//߂폜Đ𕪂
void ToolCut::CutSegment(const FindResult &findResult)
{
	m_path->CutCurveSegment(findResult.GetKnotIndex()
		,findResult.GetCurveIndex());
}

//؂@𓾂
int ToolCut::GetCutMode() const
{
	return ExtractOption(CUT_LOW,CUT_HI);
}

BZP_NAMESPACE_END
