#include "prefix.h"

#include "tooldeletepoint.h"
#include "event.h"
#include "findresult.h"
#include "part.h"
#include "selectmode.h"
#include "path.h"
#include "deleteknotmode.h"

/*************************************************

	ʉߓ__폜c[

**************************************************/

BZP_NAMESPACE_START

enum
{
	PHASE_IDLE,	//ĂȂ
	PHASE_EXTEND,	//ړc[̏Ă
};

ToolDeletePoint::ToolDeletePoint()
	:m_phase(PHASE_IDLE)

{
	m_condition=COND_DELETEPOINT_IDLE;
}

//쒆
bool ToolDeletePoint::IsOperating() const
{
	return m_phase==PHASE_EXTEND && ToolExtend::IsOperating();
}

//}EXLv`[Ă邩
bool ToolDeletePoint::IsCapturing() const
{
	return m_phase==PHASE_EXTEND && ToolExtend::IsCapturing();
}

//CxgԂƂɐU蕪
void ToolDeletePoint::Event(EVENT event,const FPoint & point,int key)
{
	switch(m_phase) {
	case PHASE_IDLE:
		EventIdle(event,point);
		break;

	case PHASE_EXTEND:
		EventExtend(event,point,key);
		break;
	}
}

//ĂȂԂɂ
void ToolDeletePoint::Idle(const FPoint & point)
{
	m_phase=PHASE_IDLE;
	Idle_Move(point);
}

//ĂȂԂ̃Cxg
void ToolDeletePoint::EventIdle(EVENT event,const FPoint & point)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_MOUSEMOVE:
		Idle_Move(point);
		break;

	case EVENT_LEFTDOWN:
		Start(point);
		break;
	}
}

//}EX̍{^
void ToolDeletePoint::Start(const FPoint & point)
{
	FindResult findResult(point);
	m_path->Find(&findResult,m_graph,PART_KNOT);

	int knotIndex=findResult.GetKnotIndex();
	int curveIndex=findResult.GetCurveIndex();

	switch(findResult.GeneralPart()) {
	case PART_ANCHOR:
		if(findResult.IsKnotOnSelectedCurve()) {
			m_path->DeleteKnot(GetDeleteMode(),knotIndex,curveIndex);
		} else {
			m_path->SelectCurve(SELECTMODE_SINGLE,curveIndex);
		}
		SetModifiedFlag();
		break;

	case PART_CONTROL:
		m_path->CurveKnot(false,findResult.GetPart(),knotIndex,curveIndex);
		SetModifiedFlag();
		break;

	default:
		ToolExtend::Start(point);
		m_phase=PHASE_EXTEND;
		break;
	}
}

//}EXړ
void ToolDeletePoint::Idle_Move(const FPoint & point)
{
	FindResult findResult(point);
	m_path->Find(&findResult,m_graph,PART_KNOT);

	switch(findResult.GeneralPart()) {
	case PART_ANCHOR:
		m_condition=COND_DELETE_KNOT;
		break;

	case PART_CONTROL:
		m_condition=COND_DELETE_CONTROL;
		break;

	default:
		if(!ToolExtend::Idle_Move(point)) {
			m_condition=COND_DELETEPOINT_IDLE;
		}
		break;
	}
}

//ړc[̃Cxg
void ToolDeletePoint::EventExtend(EVENT event,const FPoint & point,int key)
{
	ToolExtend::Event(event,point,key);
	if(event==EVENT_CANCEL || !ToolExtend::IsOperating()) {
		Idle(point);
	}
}

//폜@𓾂
DELETEKNOTMODE ToolDeletePoint::GetDeleteMode() const
{
	int option=ExtractOption(DELETEPOINT_LOW,DELETEPOINT_HI);

	return static_cast<DELETEKNOTMODE>(option>>DELETEPOINT_LOW);
}

BZP_NAMESPACE_END
