#include "prefix.h"

#include "toolextend.h"
#include "toolmove.h"
#include "event.h"
#include "path.h"
#include "runtimeconfig.h"
#include "part.h"

/*************************************************

	c[̋󂢂Ă@\Ɉړ̋@\邽߂
	n

**************************************************/

BZP_NAMESPACE_START

enum 
{
	PHASE_IDLE,	//ĂȂ
	PHASE_MOVEWCONTROLS,	//𗼑ɐL΂NbNďI
	PHASE_DRAGWCONTROLS,	//𗼑ɐL΂{^𗣂ďI
	PHASE_MOVE,	//ړc[̏Ă
};

ToolExtend::ToolExtend()
	:m_phase(PHASE_IDLE)
{
	
}

//쒆
bool ToolExtend::IsOperating() const
{
	return m_phase!=PHASE_IDLE;
}

//}EXLv`[邩
bool ToolExtend::IsCapturing() const
{
	return m_phase!=PHASE_IDLE
		&& (m_phase!=PHASE_MOVE || ToolMove::IsCapturing());
}

//ԂƂɃCxgU蕪
void ToolExtend::Event(EVENT event,const FPoint & point,int key)
{
	switch(m_phase) {
	case PHASE_IDLE:
		break;

	case PHASE_DRAGWCONTROLS:
		EventDragWControls(event,point);
		break;

	case PHASE_MOVEWCONTROLS:
		EventMoveWControls(event,point);
		break;

	case PHASE_MOVE:
		EventMove(event,point,key);
		break;
	}
}

//ĂȂԂɂ
void ToolExtend::Idle(const FPoint & point)
{
	m_phase=PHASE_IDLE;
	ToolMove::Idle(point);
}

//ĂȂԂŃJ[\𓮂
bool ToolExtend::Idle_Move(const FPoint & point)
{
	return ToolMove::Idle_Move(point);
}

//ĂȂԂōNbN
void ToolExtend::Start(const FPoint & point)
{
	m_phase=PHASE_MOVE;
	ToolMove::Start(point);
}

//𗼑փhbOŐL΂
void ToolExtend::DragWControls(const FPoint & point,bool isForward,int knotIndex,int curveIndex)
{
	m_phase=PHASE_DRAGWCONTROLS;
	m_condition=COND_MOVE_WCONTROLS;
	m_grippedKnot=knotIndex;
	m_grippedCurve=curveIndex;
	m_grippedIsForward=isForward;
	MoveLastKnotWControls(point);
	SetModifiedFlag();
}

//hbOŐL΂ĂƂ̃Cxg
void ToolExtend::EventDragWControls(EVENT event,const FPoint & point)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_MOUSEMOVE:
		MoveLastKnotWControls(point);
		break;

	case EVENT_LEFTUP:
	case EVENT_CANCEL:
		Idle(point);
		break;
	}
}

//𗼑֐L΂
void ToolExtend::MoveWControls(const FPoint & point,bool isForward,int knotIndex,int curveIndex)
{
	m_phase=PHASE_MOVEWCONTROLS;
	m_condition=COND_MOVE_WCONTROLS;
	m_grippedKnot=knotIndex;
	m_grippedCurve=curveIndex;
	m_grippedIsForward=isForward;
	MoveLastKnotWControls(point);
	SetModifiedFlag();
}

//𗼑֐L΂ĂԂ̃Cxg
void ToolExtend::EventMoveWControls(EVENT event,const FPoint & point)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_MOUSEMOVE:
		MoveLastKnotWControls(point);
		break;

	case EVENT_LEFTDOWN:
	case EVENT_CANCEL:
		Idle(point);
		break;
	}
}

//𗼑ɐL΂ꂪIƃc[͉ĂȂԂɖ߂
void ToolExtend::MoveLastKnotWControls(const FPoint & point)
{
	FPoint point_(point);	//傢ƕϊ邩Ȃꍇɂǂϐ炢̂Ȃ
	if(IsPushingKey(KEY_MOVE_CONTROL_FIXANGLE)) {
		FPoint anchorPoint=m_path->GetPoint(PART_ANCHOR,m_grippedKnot,m_grippedCurve);
		point_.FixAngle(anchorPoint);
	}

	m_path->MoveWControls(point_,m_grippedIsForward,m_grippedKnot,m_grippedCurve);
	SetModifiedFlag();
}

//_𓮂
void ToolExtend::MoveControl(const FPoint & point,bool isForward,int knotIndex,int curveIndex)
{
	PrepareMoveControl(point,isForward,knotIndex,curveIndex);
	m_phase=PHASE_MOVE;

	ToolMove::Move(point);
	SetModifiedFlag();
}

//_hbOœ
void ToolExtend::DragControl(const FPoint & point,bool isForward,int knotIndex,int curveIndex)
{
	PrepareMoveControl(point,isForward,knotIndex,curveIndex);
	m_phase=PHASE_MOVE;
	ToolMove::Drag(point);
	SetModifiedFlag();
}

//_𓮂Ȍ
void ToolExtend::PrepareMoveControl(const FPoint & point,bool isForward,int knotIndex,int curveIndex)
{
	ToolMove::SetGripPart(point,
		isForward?PART_FORWARDCONTROL:PART_BACKCONTROL
		,knotIndex,curveIndex);
}

//ړc[̃Cxg
void ToolExtend::EventMove(EVENT event,const FPoint & point,int key)
{
	ToolMove::Event(event,point,key);
	if(event==EVENT_CANCEL || !ToolMove::IsOperating()) {
		Idle(point);
	}
}

BZP_NAMESPACE_END
