#ifndef BZP_TOOLHOLDER_H
#define BZP_TOOLHOLDER_H

#include "site.h"

#ifdef __cplusplus
#include <memory>
#include <windows.h>
#endif

/*************************************************

	c[IuWFNg̏LƐ؂ւ

**************************************************/

BZP_NAMESPACE_START

/*ϊL[gݍ킹̐+4̓IvVeXgp*/
# define TOOLHOLDER_KEY_COUNT (3+4)

/*c[ϊ\̌^*/

#include "structpack_on.h"

struct ToolKeySet
{
	LONG tool;
	LONG option;
};
struct tagToolTable
{
	struct ToolKeySet keyset[TOOLHOLDER_KEY_COUNT+1];
};

#include "structpack_off.h"

typedef tagToolTable TOOLTABLE;


/*̕ϊ\Ɏgc[gȂꍇ̓AvP[V
\`Ȃ΂Ȃ*/
#if defined(BZP_DONT_USE_MOVE)	\
	|| defined(BZP_DONT_USE_INSERTKNOT)	\
	|| defined(BZP_DONT_USE_DELETEPOINT) \
	|| defined(BZP_DONT_USE_CHANGECONTROL) \
	|| defined(BZP_DONT_USE_SELECTKNOTS)
# ifndef BZP_DONT_USE_DEFAULT_TOOLTABLE
#  define BZP_DONT_USE_DEFAULT_TOOLTABLE
# endif 
#endif

/*̃c[ϊ\̍ږ*/
#ifndef BZP_DONT_USE_DEFAULT_TOOLTABLE
enum TOOLTABLE_INDEX
{

	TOOLTABLE_NONE,

	TOOLTABLE_MOVE,

#ifndef BZP_DONT_USE_PEN
	TOOLTABLE_PEN,
#endif
	TOOLTABLE_INSERTKNOT,
	TOOLTABLE_DELETEPOINT,
	TOOLTABLE_CHANGECONTROL,
#ifndef BZP_DONT_USE_CUT
	TOOLTABLE_CUT,
#endif
#ifndef BZP_DONT_USE_SHAPE
	TOOLTABLE_BOX,
	TOOLTABLE_CIRCLE,
#endif
	TOOLTABLE_SELECTKNOTS,

	TOOLTABLE_COUNT
};
#endif /*BZP_DONT_USE_DEFAULT_TOOLTABLE*/

#ifdef __cplusplus
class ToolBase;
class Path;
class Graph;
enum EVENT;
enum TOOL;

class ToolHolder
{
public:
	ToolHolder();
	ToolHolder(const TOOLTABLE *toolTable,int count);
	~ToolHolder() throw();

	void SetToolTable(const TOOLTABLE *toolTable,int count);

	int GetCurrentIndex() const;
	void SelectTool(int index,Path *path,Graph *graph);

	void Entry(EVENT event,Path *path,Graph *graph,POINT point,int key=0);
	void Entry(EVENT event,Path *path,Graph *graph);
	void Draw(Path *path,Graph *graph);
	void Cancel(Path *path,Graph *graph);

	bool IsOperating() const;
	bool CanStop() const;
	bool IsCapturing() const;
	int GetCondition() const;

	void ClearModifiedFlag();
	bool DidModify() const;

	int	GetToolOption(int lowBit=-1,int hiBit=-1) const;
protected:
	void SetTool(int index,int key);
	void AlternateTool(Path *path,Graph *graph,POINT point);
	ToolBase *CreateToolObject(TOOL tool);

private:
	std::auto_ptr<ToolBase> m_toolObj;
	int m_currentIndex;
	int m_currentKey;
	TOOL m_currentTool;

	const TOOLTABLE *m_toolTable;
	int m_tableCount;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif
