#include "prefix.h"

#include "toolinsertknot.h"
#include "findresult.h"
#include "fpoint.h"
#include "path.h"
#include "event.h"
#include "selectmode.h"

/*************************************************

	_̒ǉc[

**************************************************/

BZP_NAMESPACE_START

enum
{
	PHASE_IDLE,	//ĂȂ
	PHASE_PUTKNOT,	//pڂǉ
	PHASE_EXTEND,	//ړc[̏Ă
};


ToolInsertKnot::ToolInsertKnot()
	:m_phase(PHASE_IDLE)
{
	m_condition=COND_INSERTKNOT_IDLE;
}

ToolInsertKnot::~ToolInsertKnot() throw()
{

}

//쒆
bool ToolInsertKnot::IsOperating() const
{
	return m_phase==PHASE_PUTKNOT 
		||(m_phase==PHASE_EXTEND && ToolExtend::IsOperating());
}

//}EXLv`[邩
bool ToolInsertKnot::IsCapturing() const
{
	return m_phase==PHASE_PUTKNOT
		||(m_phase==PHASE_EXTEND && ToolExtend::IsCapturing());
}

//ԂƂɃCxgU蕪
void ToolInsertKnot::Event(EVENT event,const FPoint & point,int key)
{
	switch(m_phase) {
	case PHASE_IDLE:
		EventIdle(event,point);
		break;

	case PHASE_PUTKNOT:
		EventPutKnot(event,point);
		break;

	case PHASE_EXTEND:
		EventExtend(event,point,key);
		break;
	}
}

//ĂȂԂɂ
void ToolInsertKnot::Idle(const FPoint & point)
{
	m_phase=PHASE_IDLE;
	Idle_Move(point);
}

//ĂȂԂ̃Cxg
void ToolInsertKnot::EventIdle(EVENT event,const FPoint & point)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_MOUSEMOVE:
		Idle_Move(point);
		break;

	case EVENT_LEFTDOWN:
		Start(point);
		break;
	}
}

//ĂȂԂŃ}EXړ
void ToolInsertKnot::Idle_Move(const FPoint & point)
{
	FindResult findResult(point);
	int findPart=PART_CURVE;
	if(DoesMoveAnchor()) {
		findPart=PART_CURVE|PART_KNOT;
	}
	m_path->Find(&findResult,m_graph,findPart);

	if(findResult.GeneralPart()==PART_CURVE) {
		m_condition=COND_INSERT_KNOT;
	} else if(!ToolExtend::Idle_Move(point)) {
		m_condition=COND_INSERTKNOT_IDLE;
	}
}

//ĂȂԂŃ}EX̍{^
void ToolInsertKnot::Start(const FPoint & point)
{
	int findPart=PART_CURVE;
	if(DoesMoveAnchor()) {
		findPart=PART_CURVE|PART_KNOT;
	}
	FindResult findResult(point);
	m_path->Find(&findResult,m_graph,findPart);

	if(findResult.IsCurve()) {
		int curveIndex=findResult.GetCurveIndex();
		m_path->SelectCurve(SELECTMODE_ADD,curveIndex);
		int knotIndex=findResult.GetKnotIndex();
		int newKnotIndex=m_path->InsertKnot(GetInsertMode()
			,findResult.GetCurve_t(),knotIndex,curveIndex);
		m_path->SelectKnot(SELECTMODE_ADD,newKnotIndex,curveIndex);

		m_insertKnot=newKnotIndex;
		m_insertCurve=curveIndex;
		m_phase=PHASE_PUTKNOT;
		SetModifiedFlag();
	} else {
		ToolExtend::Start(point);
		m_phase=PHASE_EXTEND;
	}
}

//pڂuԂ̃Cxg
void ToolInsertKnot::EventPutKnot(EVENT event,const FPoint &point)
{
	switch(event) {
	case EVENT_DRAW:
		OnDraw();
		break;

	case EVENT_DRAG:
		DragWControls(point);
		break;

	case EVENT_LEFTUP:
	case EVENT_CANCEL:
		Idle(point);
		break;
	}
}

//𗼕ɃhbOĐL΂
void ToolInsertKnot::DragWControls(const FPoint &point)
{
	ToolExtend::DragWControls(point,true,m_insertKnot,m_insertCurve);
	m_phase=PHASE_EXTEND;
}

//ړc[̃Cxg
void ToolInsertKnot::EventExtend(EVENT event,const FPoint &point,int key)
{
	ToolExtend::Event(event,point,key);
	if(event==EVENT_CANCEL || !ToolExtend::IsOperating()) {
		Idle(point);
	}
}

//ʉߓ_FĈړ邩
bool ToolInsertKnot::DoesMoveAnchor() const
{
	int option=ExtractOption(INSERTKNOT_ANCHOR_LOW,INSERTKNOT_ANCHOR_HI);
	return option==OPTION_INSERTKNOT_MOVE_ANCHOR;
}

//Ɍpڂ̉
INSERTKNOTMODE ToolInsertKnot::GetInsertMode() const
{
	int option=ExtractOption(INSERTKNOT_STRAIGHT_LOW,INSERTKNOT_STRAIGHT_HI);
	int insertKnotMode=option>>INSERTKNOT_STRAIGHT_LOW;

	return static_cast<INSERTKNOTMODE>(insertKnotMode);
}

BZP_NAMESPACE_END


