#ifndef BZP_TOOLMOVE_H
#define BZP_TOOLMOVE_H

#include "site.h"

#include "movecurvemode.h"
#include "selectmode.h"
#include "tool.h"
#include "toolbase.h"

#ifdef __cplusplus
#include <memory>
#include "fpoint.h"
#endif

/*************************************************

	ړc[

**************************************************/

BZP_NAMESPACE_START

enum CONDITION_MOVE	/*ڍׂȏ*/
{
	CONDITION_MOVE_START=TOOL_MOVE*CONDITION_MULTIPLE-1,

	COND_MOVE_IDLE,	/*ĂȂ`I*/
	COND_MOVE_KNOT,	/*pڂړĂ*/
	COND_MOVE_CHAIN,	/*pڂړĂđ̐[ƂȂ*/
	COND_MOVE_CLOSE,	/*pڂړĂĐ*/
	COND_MOVE_CONTROL,	/*_ړĂ*/
	COND_MOVE_CURVE,	/*ړĂ*/
	COND_MOVE_SUBGROUP,	/*O[vړĂ*/
	COND_MOVE_FIND_ANCHOR,	/*ʉߓ_̏ɃJ[\*/
	COND_MOVE_FIND_CONTROL,	/*_̏ɃJ[\*/
	COND_MOVE_FIND_CURVE,	/*̏ɃJ[\*/
	COND_MOVE_FIND_SUBGROUP,	/*O[v̏ɃJ[\*/

	/*`I*/
	COND_SELECTBOX,	/*`͈̔͂őIꍇɔ͈͂𓮂Ă*/

	CONDITION_MOVE_MAX
};

enum OPTION_MOVE	/*c[IvV*/
{
	/*ړ̓*/
	MOVE_MOVE_LOW=0,
		OPTION_MOVE_DRAG=0 <<MOVE_MOVE_LOW,	/*hbOĈړ*/
		OPTION_MOVE_NODRAG=1 <<MOVE_MOVE_LOW,	/*ŏ̃NbNłŌ̃NbNŒu*/
		OPTION_MOVE_2WAY=2 <<MOVE_MOVE_LOW,	/**/
	MOVE_MOVE_HI=MOVE_MOVE_LOW+2,

	/*񂾏ꍇ*/
	MOVE_CURVE_LOW=MOVE_MOVE_HI,
		/*IĂSĂ̂܂܂̌`ňړ*/
		OPTION_MOVE_CURVE_ALLSELECTED
			=MOVECURVE_ALLSELECTED <<MOVE_CURVE_LOW,
		/*̂܂܈ړ*/
		OPTION_MOVE_CURVE_JUST
			=MOVECURVE_JUST <<MOVE_CURVE_LOW,
		/*2̌pڂړ*/
		OPTION_MOVE_CURVE_SEGMENT
			=MOVECURVE_SEGMENT <<MOVE_CURVE_LOW,
/*		OPTION_MOVE_CURVE_BEND=MOVECURVE_BEND <<MOVE_CURVE_LOW,	//Ȃ gȂ*/
	MOVE_CURVE_HI=MOVE_CURVE_LOW+2,

	/*TuO[v̈ړ*/
	MOVE_SUBGROUP_LOW=MOVE_CURVE_HI,
		/*ƈꏏɈړ*/
		OPTION_MOVE_SUBGROUP_WITH_CURVE
			=0 <<MOVE_SUBGROUP_LOW,
		/*pڂƈꏏɈړ*/
		OPTION_MOVE_SUBGROUP_WITH_KNOT
			=1 <<MOVE_SUBGROUP_LOW,
		/*TuO[vňړ*/
		OPTION_MOVE_SUBGROUP_ONLY
			=2	<<MOVE_SUBGROUP_LOW,
	MOVE_SUBGROUP_HI=MOVE_SUBGROUP_LOW+2,

	/*_̑I@*/
	MOVE_SELECT_LOW=MOVE_SUBGROUP_HI,
		/*IĂȂΑ̑IĈI*/
		OPTION_SELECT_SINGLE
			=SELECTMODE_SINGLE <<MOVE_SELECT_LOW,
		/*Iǉ*/
		OPTION_SELECT_ADD
			=SELECTMODE_ADD <<MOVE_SELECT_LOW,
		/*I؂ւ*/
		OPTION_SELECT_TOGGLE
			=SELECTMODE_TOGGLE <<MOVE_SELECT_LOW,
	MOVE_SELECT_HI=MOVE_SELECT_LOW+2,

	MOVE_OPTION_BITS_MAX=MOVE_SELECT_HI
};

#ifdef __cplusplus

class FindResult;
class Redraw;
class Knot;
enum SELECTMODE;
enum EVENT;
class ToolMoveMember;

class ToolMove : public ToolBase
{
public:
	ToolMove();
	virtual ~ToolMove() throw();

	virtual bool IsOperating() const;
	virtual bool IsCapturing() const;

protected:
	virtual void Event(EVENT event,const FPoint & point,int key);
	void EventIdle(EVENT event,const FPoint & point);
	void EventGripped(EVENT event,const FPoint & point);
	void EventSelectAndGripped(EVENT event,const FPoint & point);
	void EventMove(EVENT event,const FPoint & point);
	void EventDrag(EVENT event,const FPoint & point);
	void EventPutSelectBox(EVENT event,const FPoint & point);
	void EventMoveSelectBox(EVENT event,const FPoint & point);
	void EventDragSelectBox(EVENT event,const FPoint & point);
	void Idle(const FPoint & point);
	bool Idle_Move(const FPoint & point);
	void Start(const FPoint & point);
	void Grip(const FPoint & point,bool grippedIsSelected);
	void SelectAndGrip();
	void Drag(const FPoint & point);
	void Release(const FPoint & point);
	void Move(const FPoint & point);
	void MoveParts(const FPoint & point);
	void PutSelectBox();
	void MoveSelectBox(const FPoint & point);
	void DragSelectBox(const FPoint & point);
	void SelectBox_Move(const FPoint & point);
	void EndSelectBox(const FPoint & point);

	void DrawSelectBox();
	int MoveMode() const;
	SELECTMODE SelectMode() const;
	int MoveSubGroupMode() const;
	MOVECURVEMODE MoveCurveMode() const;
	void SetIgnoreKnot(FindResult *findResult) const;
	void ChainFindKnotAndGrippedKnot(const FindResult &findResult);
	void MoveAnchor(FPoint *point);
	void MoveControl(FPoint *point);
	void MoveCurve(const FPoint &point);
	void MoveSubGroup(const FPoint &point);

	void SetGripPart(const FPoint & point,int part,int knotIndex,int curveIndex);
private:
	const std::auto_ptr<ToolMoveMember> m_m;
	int m_grippedKnot;
	int m_grippedCurve;
	int m_grippedSubGroup;
	int m_grippedPart;
	int m_phase;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif

