#ifndef BZP_TOOLPEN_H
#define BZP_TOOLPEN_H

#ifdef __cplusplus
#include <memory>
#endif

#include "site.h"
#include "toolextend.h"
#include "tool.h"

/*************************************************

	yc[

**************************************************/

BZP_NAMESPACE_START

enum CONDITION_PEN	/*ڍׂȏ*/
{
	CONDITION_PEN_START=TOOL_PEN*CONDITION_MULTIPLE-1,

	COND_PEN_IDLE,	/*ĂȂVɐǉ*/
	COND_PEN_MOVE,	/*o[oh\ĈړĂ顃IvVŕ\ĂȂ܂ޡ*/
	COND_PEN_CHAIN,	/*̐ƂȂ*/
	COND_PEN_CLOSE,	/**/
	COND_PEN_TERMINATE,	/*NbNƏI*/
	COND_PEN_OUTSIDE,	/*J[\EChE̊Oɂ*/
};

enum OPTION_PEN	/*yc[̃IvV*/
{
	PEN_OPTION_INHERIT=MOVE_OPTION_BITS_MAX,

	PEN_RUBBER_LOW=PEN_OPTION_INHERIT,
		/*o[oh\*/
		OPTION_PEN_RUBBER
			=0 <<PEN_RUBBER_LOW,
		/*o[oh\Ȃ*/
		OPTION_PEN_NORUBBER
			=1 <<PEN_RUBBER_LOW,
	PEN_RUBBER_HI=PEN_RUBBER_LOW+1,
};

#ifdef __cplusplus

class FindResult;
class Redraw;
class FPoint;
class ToolPenMember;

class ToolPen : public ToolExtend
{
public:
	ToolPen();

	virtual bool IsOperating() const;
	virtual bool IsCapturing() const;
	virtual bool CanStop() const;

protected:
	virtual void Event(EVENT event,const FPoint & point,int key);
	void OnDraw();
	void Idle(const FPoint & point);
	void EventIdle(EVENT event,const FPoint & point);
	void Idle_Move(const FPoint & point);
	void Start(const FPoint & point);
	void SetFirstKnot(const FindResult &findResult,const FPoint & point);
	void PutKnot(const FPoint & point);
	void EventPutKnot(EVENT event,const FPoint & point);
	void ChainKnot(const FindResult &findResult);
	void EventChainKnot(EVENT event,const FPoint & point);
	void ChainKnot_Move(const FPoint & point);
	void DragWControls(const FPoint & point);
	void MoveWControls(const FPoint & point);
	void EventMoveWControls(EVENT event,const FPoint & point,int key);
	void Move(const FPoint & point);
	void EventMove(EVENT event,const FPoint & point,int key);
	void Move_KeyDown(const FPoint & point,int key);
	void Move_KeyUp(const FPoint & point,int key);
	void Move_Undo(const FPoint & point);
	void Move_Redo(const FPoint & point);
	void Terminate();
	void Terminate_LeftDown(const FPoint & point);
	void EventTerminate(EVENT event,const FPoint & point,int key);
	void EventExtend(EVENT event,const FPoint & point,int key);
	void Outside();
	void EventOutside(EVENT event,const FPoint & point);

	bool FindEndAnchor(const FPoint & point) const;
	bool FindEndAnchor(FindResult *findResult) const;
	void SetIgnoreKnot(FindResult *findResult) const;
	void SetFindKnotToLastKnot(const FindResult &findResult);
	void SetNewCurveToLastKnot(const FPoint & point);
	void ChainFindKnotAndLastKnot(const FindResult &findResult);
	void AddLastKnot(const FPoint & point);
	void MoveLastKnotWControls(const FPoint & point);
	void SetRubberBand(const FindResult &findResult,const FPoint & point);
	void RubberChainFindKnot(const FindResult &findResult);
	void RubberNoChain(const FPoint & point);
	void DrawRubberBand() const;

	bool DoesDrawRubberBand() const;
private:
	const std::auto_ptr<ToolPenMember> m_m;
	int m_phase;

	int m_addCount;		/*pڂǉ*/

	int m_terminate_curveCount;

	int m_lastKnot;
	int m_lastCurve;
	bool m_grippedIsForward;
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif

