#ifndef BZP_TOOL_SHAPE_H
#define BZP_TOOL_SHAPE_H

#ifdef __cplusplus
#include <memory>
#endif

#include "site.h"
#include "toolbase.h"
#include "tool.h"

/*************************************************

	lpƉ~c[

**************************************************/

BZP_NAMESPACE_START

enum CONDITION_SHAPE	/*ڍׂȏ*/
{
	CONDITION_SHAPE_START=TOOL_SHAPE*CONDITION_MULTIPLE-1,

	COND_SHAPE_IDLE,	/*ĂȂ*/
	COND_SHAPE_MOVE,	/*I_ړ*/
};

enum OPTION_SHAPE	/*c[IvV*/
{
	SHAPE_MOVE_LOW=0,
		OPTION_SHAPE_2WAY=0<<SHAPE_MOVE_LOW, /**/
		OPTION_SHAPE_DRAG=1<<SHAPE_MOVE_LOW, /*ŏ̃NbNŎn_ÃNbNŏI_*/
		OPTION_SHAPE_NODRAG=2<<SHAPE_MOVE_LOW, /*hbOĈړ*/
	SHAPE_MOVE_HI=SHAPE_MOVE_LOW+2,

	SHAPE_START_LOW=SHAPE_MOVE_HI,
		OPTION_SHAPE_CORNER=0<<SHAPE_START_LOW,	/*n_͊p*/
		OPTION_SHAPE_CENTER=1<<SHAPE_START_LOW,	/*n_͒S*/
	SHAPE_START_HI=SHAPE_START_LOW+1,

	SHAPE_SQUARE_LOW=SHAPE_START_HI,
		OPTION_SHAPE_NOT_SQUARE=0<<SHAPE_SQUARE_LOW,	/*`ł͂Ȃ*/
		OPTION_SHAPE_SQUARE=1<<SHAPE_SQUARE_LOW,	/*`*/
	SHAPE_SQUARE_HI=SHAPE_SQUARE_LOW+1,

	SHAPE_SHAPE_LOW=SHAPE_SQUARE_HI,
		OPTION_SHAPE_BOX=0<<SHAPE_SHAPE_LOW,	/*lp`*/
		OPTION_SHAPE_CIRCLE=1<<SHAPE_SHAPE_LOW,	/*~*/
	SHAPE_SHAPE_HI=SHAPE_SHAPE_LOW+1,
};

#ifdef __cplusplus

class ToolShapeMember;
class FPoint;
class FRect;
enum EVENT;

class ToolShape : public ToolBase
{
public:
	ToolShape();
	virtual ~ToolShape() throw();

	virtual bool IsOperating() const;
	virtual bool IsCapturing() const;

protected:
	virtual void Event(EVENT event,const FPoint &point,int key);
	void Idle();
	void EventIdle(EVENT event,const FPoint &point);
	void Start(const FPoint &point);
	void EventPut(EVENT event);
	void EventMove(EVENT event,const FPoint &point);
	void EventDrag(EVENT event,const FPoint &point);
	void End(const FPoint &point);	
	void DrawShape();
	void EraseShape();
	
	int MoveMode() const;
	bool DoesStartCorner() const;
	bool IsSquare() const;
	int ShapeMode() const;

	void PutBox(const FRect &rect);
	void PutCircle(const FRect &rect);

	void CalcRect(FRect *rect,const FPoint &cornerA,const FPoint &cornerB,bool doesStartCorner,bool isSquare) const;
private:
	const std::auto_ptr<ToolShapeMember> m_m;
	int m_phase;	/**/
};

#endif /*__cplusplus*/

BZP_NAMESPACE_END

#endif

