#ifndef SAMPLE_CLIPBOARD_H
#define SAMPLE_CLIPBOARD_H

#include <windows.h>

#include "site.h"

/*************************************************

	Nbv{[hAPI̊Ǘ

**************************************************/

SAMPLE_NAMESPACE_START

class Clipboard
{
public:
	Clipboard()
		:m_isOpened(false)
	{
	}
	~Clipboard() throw()
	{
		Close();
	}

	bool Open(HWND hwnd)
	{
		assert(!m_isOpened);
		bool success=::OpenClipboard(hwnd)!=FALSE;
		m_isOpened=success;
		return success;
	}

	void Clear()
	{
		assert(m_isOpened);
		::EmptyClipboard();
	}

	void SetData(UINT format,HANDLE data)
	{
		assert(m_isOpened);
		::SetClipboardData(format,data);
	}

	HANDLE GetData(UINT format)
	{
		assert(m_isOpened);
		return ::GetClipboardData(format);
	}

	void Close() throw()
	{
		if(m_isOpened) {
			::CloseClipboard();
			m_isOpened=false;
		}
	}

private:
	bool m_isOpened;
};

SAMPLE_NAMESPACE_END

#endif
