#include "prefix.h"

#include <windows.h>
#include <assert.h>

#include "command.h"
#include "toolbar.h"

/*************************************************

	j[{^̕\XV

**************************************************/

SAMPLE_NAMESPACE_START

enum
{
	TYPE_NONE,	//܂ݒ肳ĂȂ
	TYPE_MENU,	//j[
	TYPE_TOOLBAR,	//c[o[̃{^
};


Command::Command()
	:m_type(TYPE_NONE)
{

}

Command::~Command()
{

}

void Command::SetMenu(HMENU menu,int index)
{
	m_type=TYPE_MENU;
	m_menu.menu=menu;
	m_menu.index=index;
}

void Command::SetToolbar(HWND toolbar,WORD id)
{
	m_type=TYPE_TOOLBAR;
	m_toolbar.toolbar=toolbar;
	m_toolbar.id=id;
}

void Command::SetCheck(bool isChecked)
{
	switch(m_type) {
	case TYPE_MENU:
		SetCheckMenu(m_menu.menu,m_menu.index,isChecked);
		break;

	case TYPE_TOOLBAR:
		SetCheckToolbar(m_toolbar.toolbar,m_toolbar.id,isChecked);
		break;

	default:
		assert(false);
		break;
	}
}

void Command::SetCheckMenu(HMENU menu,int index,bool isChecked)
{
	UINT check=MF_BYPOSITION;
	if(isChecked) {
		check|=MF_CHECKED;
	} else {
		check|=MF_UNCHECKED;
	}
	::CheckMenuItem(menu,index,check);
}

void Command::SetCheckToolbar(HWND toolbar,WORD id,bool isChecked)
{
	ToolbarButtonCheck(toolbar,id,isChecked);
}

void Command::SetEnable(bool isEnabled)
{
	switch(m_type) {
	case TYPE_MENU:
		SetEnableMenu(m_menu.menu,m_menu.index,isEnabled);
		break;

	case TYPE_TOOLBAR:
		SetEnableToolbar(m_toolbar.toolbar,m_toolbar.id,isEnabled);
		break;

	default:
		assert(false);
		break;
	}
}

void Command::SetEnableMenu(HMENU menu,int index,bool isEnabled)
{
	UINT enable=MF_BYPOSITION;
	if(isEnabled) {
		enable|=MF_ENABLED;
	} else {
		enable|=MF_GRAYED;
	}
	::EnableMenuItem(menu,index,enable);
}

void Command::SetEnableToolbar(HWND toolbar,WORD id,bool isEnabled)
{
	ToolbarButtonEnable(toolbar,id,isEnabled);
}

SAMPLE_NAMESPACE_END
