#ifndef SAMPLE_DC_H
#define SAMPLE_DC_H

#include <windows.h>

#include "site.h"

/*************************************************

	foCXReLXg̊Ǘ

**************************************************/

SAMPLE_NAMESPACE_START

class DC
{
public:
	DC(HWND hwnd)
		:m_hDC(NULL)
		,m_hwnd(hwnd)
	{
	}

	HDC GetDC()
	{
		return m_hDC;
	}
protected:
	HDC m_hDC;
	HWND m_hwnd;
};

class PaintDC : public DC
{
public:
	PaintDC(HWND hwnd)
		:DC(hwnd)
	{
		::BeginPaint(hwnd,&m_paintStruct);
		m_hDC=m_paintStruct.hdc;
	}

	~PaintDC() throw()
	{
		Delete();
	}

	void Delete() throw()
	{
		::EndPaint(m_hwnd,&m_paintStruct);
	}
private:
	PAINTSTRUCT m_paintStruct;
};

class ClientDC : public DC
{
public:
	ClientDC(HWND hwnd)
		:DC(hwnd)
	{
		m_hDC=::GetDC(hwnd);
	}

	~ClientDC() throw()
	{
		Delete();
	}

	void Delete() throw()
	{
		::ReleaseDC(m_hwnd,m_hDC);
	}
};

SAMPLE_NAMESPACE_END

#endif
