#include "prefix.h"

#include <windows.h>
#include <commdlg.h>

#include "filedialog.h"
#include "main.h"
#include "resource.h"

/*************************************************

	t@C_CAO

**************************************************/

SAMPLE_NAMESPACE_START

FileDialog::FileDialog(UINT captionID,UINT filterID,HWND parentWnd)
{
	::ZeroMemory(&m_open,sizeof(OPENFILENAME));
	m_open.lStructSize=sizeof(OPENFILENAME);
	m_open.hwndOwner=parentWnd;
	::LoadString(g_hInstance,filterID,m_filter,FILTERMAX-1);
	m_open.lpstrFilter=m_filter;
	m_open.lpstrCustomFilter=NULL;
	m_open.nFilterIndex=0;
	m_fileName[0]=0;
	m_open.lpstrFile=m_fileName;
	m_open.nMaxFile=sizeof(m_fileName);
	m_open.lpstrFileTitle=NULL;
	m_open.lpstrInitialDir=NULL;
	::LoadString(g_hInstance,captionID,m_caption,CAPTIONMAX-1);
	m_open.lpstrTitle=m_caption;
	m_open.lpstrDefExt=NULL;
}

FileDialog::~FileDialog() throw()
{

}

bool FileDialog::OpenFileName()
{
	m_open.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST
		|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
	return ::GetOpenFileName(&m_open)!=FALSE;	
}

bool FileDialog::SaveFileName()
{
	m_open.Flags=OFN_EXPLORER|OFN_OVERWRITEPROMPT
		|OFN_HIDEREADONLY;
	return ::GetSaveFileName(&m_open)!=FALSE;
}

const char *FileDialog::GetFileName() const
{
	return m_fileName;
}

SAMPLE_NAMESPACE_END

