#ifndef SAMPLE_FRAME_H
#define SAMPLE_FRAME_H

#include "site.h"
#include "window.h"

/*************************************************

	OgEBhENX

**************************************************/

SAMPLE_NAMESPACE_START

class Document;
class View;
class Command;

class Frame : public Window
{
public:
	Frame();
	virtual ~Frame() throw();

	bool Create();
	virtual bool WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);
	View *GetView();
	void SetView(View *view);
	void SetStatusText(UINT textID);
protected:
	void OnNcDestroy();
	void OnSize(UINT type,WORD width,WORD height);
	void OnCommand(WPARAM wparam,LPARAM lparam);
	void OnInitMenuPopup(HMENU hmenu,WORD,bool isSystemMenu);
	void OnUpdateWindow();
	void OnMenuSelect(UINT item,UINT flag,HMENU menu);
	virtual void OnUpdateCommand(UINT id,Command *command);
	void OnKeyDown(WPARAM wparam,LPARAM lparam);
	void OnKeyUp(WPARAM wparam,LPARAM lparam);
private:
	View *m_view;
	Document *m_document;
	HWND m_statusBar;
	HWND m_toolBar;
};

SAMPLE_NAMESPACE_END

#endif

