#ifndef SAMPLE_HGLOBAL_H
#define SAMPLE_HGLOBAL_H

#include <windows.h>

#include "site.h"

/*************************************************

	GlobalAllocŊmۂ[̊Ǘ

**************************************************/

SAMPLE_NAMESPACE_START

class HGlobal
{
public:
	HGlobal()
		:m_handle(NULL)
		,m_lockCount(0)
	{
	}

	HGlobal(HGLOBAL handle)
		:m_handle(handle)
		,m_lockCount(0)
	{
	}

	~HGlobal() throw()
	{
		Free();
	}

	void Reset(HGLOBAL handle)
	{
		Free();
		m_handle=handle;
	}

	void Free() throw()
	{
		if(m_handle!=NULL) {
			while(m_lockCount>0) {
				Unlock();
			}
			::GlobalFree(m_handle);
			m_handle=NULL;
		}
	}

	HGLOBAL Release()
	{
		if(m_handle==NULL) return NULL;
		while(m_lockCount>0) {
			Unlock();
		}
		HGLOBAL handle=m_handle;
		m_handle=NULL;
		return handle;
	}

	void Unlock() throw()
	{
		if(m_handle!=NULL
			&& m_lockCount>0) {
			::GlobalUnlock(m_handle);
			--m_lockCount;
		}
	}

	void *Lock()
	{
		if(m_handle==NULL) return NULL;
		void *ptr=::GlobalLock(m_handle);
		if(ptr==NULL) return NULL;
		++m_lockCount;
		return ptr;
	}

	int Size() const
	{
		if(m_handle==NULL) return 0;
		return ::GlobalSize(m_handle);
	}

private:
	HGLOBAL m_handle;
	int m_lockCount;
};

SAMPLE_NAMESPACE_END

#endif
