#ifndef SAMPLE_HISTORY_H
#define SAMPLE_HISTORY_H

#include "site.h"

#include <memory>

/*************************************************

	̊Ǘ

**************************************************/

/*OԂ̃}N*/
#ifdef SAMPLE_HAS_NAMESPACE
# define HISNAME ::history
# define HIS_NAMESPACE_START namespace history {
# define HIS_NAMESPACE_END }
#else
# define HISNAME
# define HIS_NAMESPACE_START
# define HIS_NAMESPACE_END
#endif

HIS_NAMESPACE_START

class History;
class Record;

class HistoryMember;

//ǗNX
class History
{
public:
	History();
	~History() throw();

	void BeginRecord();
	void EndRecord();

	void Push(Record *record);
	void Cancel() throw();

	Record *UndoRedoFirst(bool undo);
	Record *UndoRedoNext();

	bool CanUndoRedo(bool undo) const;
protected:
	void RemoveFollowRecords(int index);
	void Seek(bool undo) throw();
	Record *GetRecord(bool undo);
private:
	const std::auto_ptr<HistoryMember> m_m;

	int m_nestCount;	//BeginRecord EndRecord̃lXg
	int m_recordedCount;	//L^Ă鐔
	int m_index;	//݂̈ʒu
	int m_modifiedCount;	//݂̈ʒuł̕ύX
	bool m_pushedFirstRecord;	//񕪂̍ŏ̗vfĂ邩
	bool m_undoRedoNow;	//ɖ߂蒼ĂŒ
	bool m_doesUndo;
};


//ێvf
class Record
{
friend History;

public:
	Record(int key,int subKey,bool doesModified);
	~Record() throw();

	void Rewind();
	void SetFirst();
	void SetLast();
	bool IsFirst() const;
	bool IsLast() const;
	bool DoesModified() const;
	int GetKey() const;
	int GetSubKey() const;

	void WriteBuffer(const char *buffer,int size);
	const char *ReadBuffer(int *size);
protected:
	void SubWriteData(const void *data,int size);
	void SubWriteInt(int value);

	int SubReadInt();
	void SubReadData(void *data,int size);
private:
	char *m_buffer;
	int m_size;
	int m_pointer;
	int m_key;
	int m_subKey;
	int m_flags;
	bool m_doesModified;
};

enum HISERROR
{
	HISERROR_OUT_OF_MEMORY,
};

//O
class Exception
{
public:
	Exception(HISERROR errorCode) throw()
	{
		m_errorCode=errorCode;
	}

	Exception(const Exception &rhs) throw()
	{
		m_errorCode=rhs.GetErrorCode();
	}

	virtual ~Exception() throw()
	{
	}

	HISERROR GetErrorCode() const throw()
	{
		return m_errorCode;
	}
private:
	Exception() throw();
	HISERROR m_errorCode;
};

HIS_NAMESPACE_END

#endif
