#ifndef SAMPLE_SAMPLEVIEW_H
#define SAMPLE_SAMPLEVIEW_H

#include "site.h"
#include "view.h"
#include <bzpath_forward.h>

/*************************************************

	Tvr[NX

**************************************************/

namespace history
{
	class Record;
}

SAMPLE_NAMESPACE_START


using namespace bzp;

class SampleMember;

class SampleDocument;
class DC;
class Command;

class SampleView : public View
{
public:
	SampleView();
	virtual ~SampleView() throw();

	virtual void OnInitialUpdate();
	virtual bool WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);

	SampleDocument *GetDocument();
	const SampleDocument *GetDocument() const;
	
	bzp::Path *SampleView::GetPath();
protected:
	virtual void OnCommand(WPARAM wparam,LPARAM lparam);

	void OnPaint();
	void OnLButtonDown(int x,int y,int keyFlags);
	void OnLButtonUp(int x,int y,int keyFlags);
	void OnLButtonDblClk(int x,int y,int keyFlags);
	void OnRButtonDown(int x,int y,int keyFlags);
	void OnMouseMove(int x,int y,int keyFlags);
	void OnKeyDown(int key,UINT keyData);
	void OnKeyUp(int key,UINT keyData);
	bool OnSetCursor(HWND hwnd,WORD hitTest,WORD mouseMessage);
	void OnActivate(WORD activateMode,bool isMinimized,HWND previousWindow);
	void OnSize(UINT type,WORD cx,WORD cy);
	void OnRenderAllFormats();
	void OnRenderFormat(UINT format);
	void OnDestroyClipboard();
	void OnCut();
	void OnCopy();
	void OnPaste();
	bool SetPathCursor();
	void CalcViewRect(RECT *rect);
	POINT GetViewPoint(int x,int y) const;
	POINT GetMessagePoint() const;
	void CallEventProcess(EVENT event,POINT point,int key);
	void OnHidePath(HWND sendhwnd,SampleDocument *hideDocument);
	void OnShowPath(HWND sendhwnd,SampleDocument *hideDocument);
	void ShowPath(bool show);
	void DrawPath();
	void OnToolButton(WORD id);
	void OnSelectTool(WORD id);
	void OnViewMagnification(WORD id);
	void OnDrawMode(WORD id);
	void SetScrollSize(SIZE docSize);
	void SelectTool(int index);
	void PutPen(double x,double y);	
	void OnHReverse();
	void OnVReverse();
	void OnGroup();
	void OnUngroup();
	void OnSteps();
	void OnFill();
	void BoundToView(RECT *viewRect,const RECT *boundRect) const;
	void RenderTagFormat();
	void RenderAIFormat();
	void OnCutKnot();
	void OnUpdateCutKnot(Command *command);
	void OnUndo();
	void OnRedo();
	void OnSelectAll();
	void OnUnselectAll();
	void UndoRedo(bool undo);
	void SetRedraw(Redraw *redraw,DC *dc);
	void BeginRedraw(Redraw *redraw,DC *dc);
	void EndRedraw(Redraw *redraw);
	void ModifyPath(void (SampleView::*handler)(),bool doesUndoRedo=false);
	void UsePath(void (SampleView::*handler)());
	void SetPreviousPath();
	void UndoRedoPath(history::Record *record,bool undo);
	virtual void OnUpdateCommand(UINT id,Command *command);
	void OnUpdateCopy(Command *command);
	void OnUpdatePaste(Command *command);
	void OnUpdateTool(WORD id,Command *command);
	void OnUpdateViewMagnification(WORD id,Command *command);
	void OnUpdateDrawMode(WORD id,Command *command);
	void OnUpdateGroup(Command *command);
	void OnUpdateUngroup(Command *command);
	void OnUpdateNotEmpty(Command *command);
	void OnUpdateUndo(Command *command);
	void OnUpdateRedo(Command *command);
	void PushHistory();

	void RecoverFailureModifyPath(int error);
	void RecoverFailureUsePath(int error);
	void ShowError(int error) const;

	void RedrawAllViews(const RECT *rect=NULL);
	void OnRedrawView(SampleDocument *document,const RECT *rect);
	void OnFileImport();
	void OnFileExport();
	void OnUpdateImport(Command *command);

	void SetWindowTitle();
	void SetPathStatusText();
private:
	const std::auto_ptr<SampleMember> m_m;

	static int sm_tool;		//ŜŐݒ肳Ăc[̎

	int m_magnification;	//hLg̊g\̔{
	SIZE m_margin;	//]̑傫
	bool m_showPath;	//pXʂ̃EBhEňꍇɁApXύXOɂ
	int m_drawMode;	//pX̕\@
	bool m_cutKnot;	//Nbv{[hɌpڂŐ؂
	bool m_isToolOperating;	//c[̓쒆
};

SAMPLE_NAMESPACE_END

#endif

