#include "prefix.h"

#include "toolbar.h"
#include "main.h"

/*************************************************

	c[o[

**************************************************/

SAMPLE_NAMESPACE_START


HWND CreateToolbar(struct ToolbarButton *buttons,int buttonCount,UINT windowId,HWND parentWindow)
{
	::InitCommonControls();

	HWND toolbar=::CreateWindowEx(
		0,TOOLBARCLASSNAME,NULL
		,WS_CHILD|TBSTYLE_TOOLTIPS|CCS_TOP
		,0,0,0,0,parentWindow,(HMENU)windowId,g_hInstance
		,NULL);

	::SendMessage(toolbar,TB_BUTTONSTRUCTSIZE,(WPARAM)sizeof(TBBUTTON),0);

	for(int i=0,bitmapCount=0;i<buttonCount;i++) {
		if(buttons[i].bitmapId!=0) {
			TBADDBITMAP addBitmap;
			addBitmap.hInst=g_hInstance;
			addBitmap.nID=buttons[i].bitmapId;
			::SendMessage(toolbar,TB_ADDBITMAP,(WPARAM)1,(LPARAM)&addBitmap);
		}

			
		int commandId=buttons[i].commandId;
//		::SendMessage(toolbar,TB_ADDSTRING,(WPARAM)g_hInstance,(LPARAM)MAKELONG(commandId,0));

		TBBUTTON tbButton;
		if(buttons[i].bitmapId!=0) {
			tbButton.iBitmap=bitmapCount;
		} else {
			tbButton.iBitmap=0;
		}
		tbButton.idCommand=commandId;
		tbButton.fsState=buttons[i].state|TBSTATE_ENABLED;
		tbButton.fsStyle=buttons[i].style|TBSTYLE_TOOLTIPS;
		tbButton.dwData=0;
		tbButton.iString=i;
		::SendMessage(toolbar,TB_ADDBUTTONS,(WPARAM)1,(LPARAM)&tbButton);

		if(buttons[i].bitmapId!=0) {
			bitmapCount++;
		}
	}

	::ShowWindow(toolbar,SW_SHOW); 
	return toolbar;
}

void ToolbarButtonCheck(HWND toolbar,WORD id,bool isChecked)
{
	::SendMessage(toolbar,TB_CHECKBUTTON
		,(WPARAM)id
		,(LPARAM)MAKELONG(isChecked?TRUE:FALSE,0));
}

void ToolbarButtonEnable(HWND toolbar,WORD id,bool isEnabled)
{
	::SendMessage(toolbar,TB_ENABLEBUTTON
		,(WPARAM)id
		,(LPARAM)MAKELONG(isEnabled?TRUE:FALSE,0));
}


SAMPLE_NAMESPACE_END
