#ifndef SAMPLE_VIEW_H
#define SAMPLE_VIEW_H

#include "site.h"
#include "window.h"

/*************************************************

	r[EBhE{NX

**************************************************/

SAMPLE_NAMESPACE_START

class Document;
class Frame;
class Command;

class View : public Window
{
public:
	View();
	virtual ~View() throw();

	bool Create(Frame *frame);
	virtual bool WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);
	Document *GetDocument();
	const Document *GetDocument() const;
	void SetDocument(Document *document);
	Frame *GetFrame();
	void SetFrame(Frame *frame);
	virtual void OnInitialUpdate();
	virtual void OnUpdateCommand(UINT id,Command *command);
	void SendMessageToAllViews(UINT message,WPARAM wparam,LPARAM lparam);
protected:
	void SetScrollSize(SIZE size);
	void OnHScroll(int scrollCode,short int pos,HWND bar);
	void OnVScroll(int scrollCode,short int pos,HWND bar);
	void OnScroll(int scrollCode,short int pos,int bar);
	virtual void OnSize(UINT type,WORD cx,WORD cy);
	void OnSizeSub(int bar,int clientSize,int scrollSize);
	POINT GetScrollPos() const;
	int GetScrollPosSub(int bar,int clientSize,int scrollSize) const;
	void OnPrepareDC(HDC hDC);
	virtual void OnCommand(WPARAM wparam,LPARAM lparam);
	void SetStatusText(UINT textID);
	int GetViewNumber() const;
private:
	Frame *m_frame;
	Document *m_document;
	SIZE m_scrollSize;
	int m_viewNumber;	//hLg̃EBhE𕡐ꍇ̔ԍ
};

SAMPLE_NAMESPACE_END

#endif

