#ifndef SAMPLE_WINDOW_H
#define SAMPLE_WINDOW_H

#include "site.h"
#include <windows.h>

/*************************************************

	EBhENX

**************************************************/

SAMPLE_NAMESPACE_START

class Window
{
public:
	Window();
	virtual ~Window() throw();

	bool Create(const char *caption,UINT style,Window *parentWindow);
	virtual bool WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);

	BOOL ShowWindow(int mode);
	BOOL DestroyWindow();
	BOOL GetClientRect(RECT *rect) const;
	HWND GetHWND() const;
	BOOL SetWindowPos(Window *wndInsertAfter,int x,int y,int cx,int cy,UINT flags);
	LONG SetWindowLong(int nIndex,LONG dwNewLong);
	BOOL SetScrollInfo(int fnBar,SCROLLINFO *pSi,BOOL redraw);
	BOOL GetScrollInfo(int fnBar,SCROLLINFO *pSi) const;
	int ScrollWindowEx(int dx,int dy,const RECT *scroll
		,const RECT *clip,HRGN updateRegion
		,RECT *updateRect,UINT flags);
	BOOL UpdateWindow();
	LRESULT SendMessage(UINT message,WPARAM wparam,LPARAM lparam);
	BOOL PostMessage(UINT message,WPARAM wparam,LPARAM lparam);
	
	BOOL InvalidateRect(const RECT *rect=NULL);
	BOOL ScreenToClient(POINT *point) const;
	BOOL ClientToScreen(POINT *point) const;
	HWND SetCapture();
	BOOL DragDetect(POINT point);
	BOOL SetWindowText(const char *text);
protected:
	void RegisterWindowClass();
	void OnNcDestroy();
private:
	HWND m_hwnd;
};

inline const int Width(RECT rect)
{
	return rect.right-rect.left;
}

inline const int Height(RECT rect)
{
	return rect.bottom-rect.top;
}

SAMPLE_NAMESPACE_END

#endif

