#include "prefix.h"

#include <windows.h>
#include <deque>
#include <algorithm>

#include "winman.h"
#include "frame.h"
#include "sampleview.h"
#include "sampledocument.h"
#include "winmessage.h"

/*************************************************

	EBhE̊Ǘ

**************************************************/

SAMPLE_NAMESPACE_START

typedef std::deque<Frame *> FrameArray;
static FrameArray *s_frames=NULL;

//AvP[V̈ԍŏ̃EBhEJ
bool CreateFirstWindow(int nCmdShow)
{
	s_frames=new FrameArray;
	SAMPLE_BAD_ALLOC_TEST(s_frames);

	Frame *frame=CreateDocumentWindow();
	if(frame==NULL) {
		return false;
	}
	frame->ShowWindow(nCmdShow);
	return true;
}

//VhLgƃEBhȆg
Frame *CreateDocumentWindow()
{
	Frame *frame=CreateFrameWindow();
	SampleDocument *document=new SampleDocument;
	SAMPLE_BAD_ALLOC_TEST(document);
	document->OnNewDocument();

	frame->GetView()->SetDocument(document);
	if(!frame->Create()) {
		frame->DestroyWindow();
		return NULL;
	}
	return frame;
}

//VEBhEāÃhLgɌт
bool CreateAlternateWindow(Document *document)
{
	Frame *frame=CreateFrameWindow();
	frame->GetView()->SetDocument(document);
	if(!frame->Create()) {
		frame->DestroyWindow();
		return false;
	}
	frame->ShowWindow(SW_SHOW);
	return true;
}

//VEBhE
Frame *CreateFrameWindow()
{
	Frame *frame=new Frame;
	SAMPLE_BAD_ALLOC_TEST(frame);
	SampleView *view=new SampleView;
	SAMPLE_BAD_ALLOC_TEST(view);

	s_frames->push_back(frame);

	frame->SetView(view);
	view->SetFrame(frame);
	return frame;
}

//t[EBhE̓o^폜
void UnregisterWindow(Frame *frame)
{
	FrameArray::iterator it=std::find(s_frames->begin(),s_frames->end(),frame);
	assert(it!=s_frames->end());
	s_frames->erase(it);

	if(s_frames->empty()) {
		::PostQuitMessage(0);
	}
}

//SẴEBhEXV
void UpdateWindows()
{
	for(int i=0;i<s_frames->size();++i) {
		(*s_frames)[i]->PostMessage(SAMPLE_WM_UPDATE_WINDOW,0,0);
	}
}

void DestroyAllWindows()
{
	while(!s_frames->empty()) {
		s_frames->at(0)->DestroyWindow();
	}
}

void SendMessageToAllViews(UINT message,WPARAM wparam,LPARAM lparam)
{
	for(int i=0;i<s_frames->size();++i) {
		View *view=(*s_frames)[i]->GetView();
		view->SendMessage(message,wparam,lparam);
	}
}

SAMPLE_NAMESPACE_END
